function Is_Legal=islegal_chrom(Individual)
% ISLEGAL_CHROM	Test whether the chromosome is legal.

%     Copyright (c) 1997-2000 Jiming Liu and Jianbing Wu

global Cell_Min_Distance Total_Cell_Num Single_Code_Width;

Robot_Config=[];
for mm=1:Total_Cell_Num
  Current_Cell_Code=Individual((mm-1)*Single_Code_Width+1:mm*...
                 Single_Code_Width);
  Robot_Config(mm,:)=get_code_config(Current_Cell_Code);
end

Is_Legal=1;

for nn=1:(Total_Cell_Num-1)
  for mm=(nn+1):Total_Cell_Num
    Robot_Diff=Robot_Config(mm,:)-Robot_Config(nn,:);
    TwoRobot_Distance=sqrt(Robot_Diff(1)^2+Robot_Diff(2)^2);
    if TwoRobot_Distance<Cell_Min_Distance
      Is_Legal=0;
      return;
    end
  end
end