function chrom1=cross_chrom(chrom,matenum,Range_Chrom)
% CROSS_CHROM	Mate two individuals. 

%     Copyright (c) 1997-2000 Jiming Liu and Jianbing Wu

mateind=[]; 
chrom1=chrom;
[pop bitlength]=size(chrom); 
ind=1:pop; 

u=floor(pop*matenum);
if floor(u/2)~=u/2
  u=u-1;
end
%select percentage to mate randomly

while length(mateind)~=u
  i=round(rand*pop);
  if i==0
    i=1;
  end
  if ind(i)~=-1
    mateind=[mateind i]; 
    ind(i)=-1;
  end
end

%perform single point crossover 
for i=1:2:u-1
  Is_Legal=0;
  while ~Is_Legal
    splitpos=floor(rand*bitlength);  % crossover point
    if splitpos==0
      splitpos=1; 
    end

    i1=mateind(i); 
    i2=mateind(i+1);
    tempgene=chrom(i1,splitpos+1:bitlength);
    New_Chromosome1=chrom(i1,:);
    New_Chromosome2=chrom(i2,:);
    New_Chromosome1(splitpos+1:bitlength)=chrom(i2,splitpos+1:bitlength);
    New_Chromosome2(splitpos+1:bitlength)=tempgene;
    Is_Legal=islegal_chrom(New_Chromosome1,Range_Chrom);
    if Is_Legal
      Is_Legal=islegal_chrom(New_Chromosome2,Range_Chrom);
    end
    if Is_Legal
      chrom1(i1,splitpos+1:bitlength)=chrom(i2,splitpos+1:bitlength);
      chrom1(i2,splitpos+1:bitlength)=tempgene;
    end
  end
end
