% EVMARLMAIN	Main program for evolutionary multiagent reinforcement learning.

%     Copyright (c) 1997-2000 Jiming Liu and Jianbing Wu

close all;
clear all;
clc;

global fit_all sum_all;
global Case_Default Case_Position Analysis_Time;
global LoopEnd_Behavior Red_Step_Matrix Stimulus_Index Stimulus_Counter;
global Red_Position White_Position;

% set the seed of random number generator.
Current_Seed=seed_generate;
%rand('seed',Current_Seed);

[Fitness_Fun,Range_Chrom,Bit_Length,Population_Size,Total_Generations,...
   Mutation_Prob,Cross_Prob,Case_Default,Case_Position,Analysis_Time]...
   =initial_para;

if Population_Size>2^Bit_Length
  disp('Error. To large population size.');
  return;
end                 % The size of population can not be larger than the
                    % possible number of the chromosomes.
if sum(Case_Position)~=Bit_Length
  disp('Error initialization.');
  return;
end                 % Condition code must be equal to the length of
                    % the chromosome.

New_Population=chrom_generat(Bit_Length,Population_Size,Range_Chrom);
     % Create the populations

genetic_process=[];
% Genetic operations till the Total_Generations
for gens=1:Total_Generations

  gens

  if gens>=10
    Mutation_Prob=0.06;
  end
  if gens>=20
    Mutation_Prob=0.005;
  end
  if gens>=30            
    Mutation_Prob=0.001;
  end
  Selected_Pop=select_gen(Fitness_Fun,New_Population);
  Crossover_Pop=cross_chrom(Selected_Pop,Cross_Prob,Range_Chrom);
  Mutate_Pop=mutate(Crossover_Pop,Mutation_Prob,Range_Chrom);
  New_Population=Mutate_Pop;
%end

% print the temproary genetic output.
  Key_Word=[];
  for loop=1:Population_Size
    Key_Word=[Key_Word;build_casename(New_Population(loop,:))];
  end
  Key_Word
  genetic_process=[genetic_process; Key_Word];
end

plot(sum_all);
xlabel('generations');
ylabel('fitness');
grid on;

clear Fitness_Fun Range_Chrom Bit_Length Population_Size Total_Generations;
clear Mutation_Prob Cross_Prob Case_Default Case_Position Analysis_Time;
clear Current_Seed New_Population Key_Word Selected_Pop Crossover_Pop;
clear Red_Step_Matrix LoopEnd_Behavior;
clear Mutate_Pop gens loop;