% PRE_FIG	Display comparable figures of robots trajectory 
%
%		and save in files.

%       Copyright (c) 1998-2000 Jiming Liu and Jianbing Wu

close all;
clear all;

SaveInterval=2;
TrajectInterval=6;

FileName='previous';                    
Keyword_m1=['../ps/' FileName '_map'];
Keyword_c1=['../ps/' FileName '_cot'];
Keyword_t1=['../ps/' FileName '_trj'];

eval(['load ../matfile/' FileName ';']);
[X,map]=bmpread('testimg.bmp');
EnvSize=size(X);

for DisplayStep=6:TrajectInterval:24
DisplayStep

PutString=['(STEP=' num2str(DisplayStep) ')'];

  BeginRow=(DisplayStep/SaveInterval-1)*MapSize(1)+1;
  EndRow=DisplayStep/SaveInterval*MapSize(1);
  PotentTemp=TotalPotent(BeginRow:EndRow,:);

  clf;
  surfl(PotentTemp);
  colormap(gray);
  shading interp;
  view(-35,70);
  title(PutString);
  SaveString=[Keyword_m1 '_' num2str(DisplayStep)];
  eval(['print ' SaveString ' -dps;']);  
  drawnow;

  clf;
  contour(PotentTemp,30);
  colormap(gray);
  title(PutString);
  SaveString=[Keyword_c1 '_' num2str(DisplayStep)];
  eval(['print ' SaveString ' -dps;']);
  drawnow;

  clf;
  colormap(map);
  for mm=1:EnvSize(1)
    Y((EnvSize(1)-mm+1),:)=X(mm,:);
  end
  image(Y);
  hold on;
  for loop1=1:RobotNum
    X_Vector=[];
    Y_Vector=[];
    DataNum=0;
    for loop2=(DisplayStep-TrajectInterval):DisplayStep
      LastConfig=AllRobotConfig(loop2*RobotNum+loop1,:)*MapGridWidth;
      X_Vector=[X_Vector LastConfig(2)];
      Y_Vector=[Y_Vector LastConfig(1)];
      if loop2==DisplayStep
        plot(LastConfig(2),EnvSize(1)-LastConfig(1)+1,...
              'Marker','*','MarkerSize',7);
      else
        plot(LastConfig(2),EnvSize(1)-LastConfig(1)+1,...
              'Marker','o','MarkerSize',7);  % too small circle.
      end
      DataNum=DataNum+1;
    end
    t=1:DataNum;
    ts=1:.2:DataNum;
    xs=spline(t,X_Vector,ts);
    ys=spline(t,Y_Vector,ts);
    plot(xs,EnvSize(1)-ys+1);
  end
  title(PutString);
  SaveString=[Keyword_t1 '_' num2str(DisplayStep)];
  eval(['print ' SaveString ' -dps;']);
  drawnow;
end  
