function process(MatFile)
% PROCESS	View the history of robot actions.

%       Copyright (c) 1998-2000 Jiming Liu and Jianbing Wu

close all;

TrajectInterval=1;

eval(['load ../matfile/' MatFile ';']);
[X,map]=bmpread('testimg.bmp');
EnvSize=size(X);

RobotLastConfig=AllRobotConfig(1:RobotNum,:);

for DisplayStep=TrajectInterval:TrajectInterval:RunTimes
DisplayStep

  clf;
  colormap(map);
  image(X);
  hold on;
  for loop1=1:RobotNum
    X_Vector=[];
    Y_Vector=[];
    DataNum=0;
    for loop2=(DisplayStep-TrajectInterval+1):(DisplayStep+1)
     if loop2 
      ThisConfig=AllRobotConfig((loop2-1)*RobotNum+loop1,:);
      if all(ThisConfig==[-1 -1])
        ThisConfig=RobotLastConfig(loop1,:);
      else
        RobotLastConfig(loop1,:)=ThisConfig;
      end
      X_Vector=[X_Vector ThisConfig(2)*MapGridWidth];
      Y_Vector=[Y_Vector ThisConfig(1)*MapGridWidth];
      if loop2==(DisplayStep+1)
        plot(ThisConfig(2)*MapGridWidth,ThisConfig(1)*MapGridWidth,'*');
      else
        plot(ThisConfig(2)*MapGridWidth,ThisConfig(1)*MapGridWidth,'o');
      end
      DataNum=DataNum+1;
     end
    end
    t=1:DataNum;
    ts=1:.2:DataNum;
    xs=spline(t,X_Vector,ts);
    ys=spline(t,Y_Vector,ts);
    plot(xs,ys);
  end
drawnow;
pause;

%  eval(['print ' MatFile '_'  num2str(DisplayStep) ' -dps;']);
end  