% SIGMAPERR	Calculate the second-moment error for map building.

%       Copyright (c) 1998-2000 Jiming Liu and Jianbing Wu

clear all;
close all;

%FileName='ballmap_s16p7w2';
%FileName='ballmap_s32p7w2';
%FileName='ballmap_s8p7w2';
%FileName='blockmap_s16p7w2';
%FileName='blockmap_s8p7w3'; 
%FileName='trianmap_s16p7w2';
FileName='trianmap_s32p3w1';

eval(['load ../matfile/' FileName ';']);

BeginPotent=ones(MapSize)*16;
TempError=BeginPotent-PrecisePotent;
BegnFirstSeg=sum(sum(TempError))/(40*40);
BegnSecSeg=sqrt(sum(sum(TempError.^2))/(40*40));
          
FirstSegment=[BegnFirstSeg];
SecondSegment=[BegnSecSeg];
for loop=1:RunTimes
  TotalMatrix=TotalPotent((loop-1)*MapSize(1)+1:loop*MapSize(1),:);
  TempError=TotalMatrix-PrecisePotent;
  TempFirstSeg=sum(sum(TempError))/(40*40);
  TempSecSeg=sqrt(sum(sum(TempError.^2))/(40*40));
  FirstSegment=[FirstSegment TempFirstSeg];
  SecondSegment=[SecondSegment TempSecSeg];
end       

TimeAxis=0:RunTimes;

%figure;
%plot(TimeAxis,FirstSegment);

figure;
plot(TimeAxis,SecondSegment);
xlabel('STEP');
ylabel('The Second Moment of the Error');
title(FileName);
  SaveString=['../ps/' FileName '_err'];
  eval(['print ' SaveString ' -dps;']);
