function GrayCode=deltacode(DeltaConfig,HalfSingle)
% DELTACODE	Convert robot configuration to its gray code representation.
%
%		And GAs chromosomes is coded in Gray mode.

%       Copyright (c) 1998-2000 Jiming Liu and Jianbing Wu

if DeltaConfig(1)>=0
  FirstSign=0;
else
  FirstSign=1;
end
if DeltaConfig(2)>=0
  SecondSign=0;
else
  SecondSign=1;
end

FirstDec=abs(DeltaConfig(1));
SecondDec=abs(DeltaConfig(2));

FirstBin=[1 int2bin(FirstDec,HalfSingle-1)];
TempGray=bin2gray(FirstBin);
FirstGray=[FirstSign TempGray(2:HalfSingle)];

SecondBin=[1 int2bin(SecondDec,HalfSingle-1)];
TempGray=bin2gray(SecondBin);
SecondGray=[SecondSign TempGray(2:HalfSingle)];

GrayCode=[FirstGray SecondGray];
