function getenvir
% GETENVIR	Normalize the ENVIRONMENT for the experiment.

%       Copyright (c) 1998-2000 Jiming Liu and Jianbing Wu

global RealEnviron FreeIndex ObstacleIndex MaxAttitude;        
global MapGridWidth EnvironSize MapSize VisitTimes;
global VisitPlusEnviron MarkColorIndex ColorMap TempPotentField;
global AccumulateNum TempPotentWeight;

EnvironName=envirini;

[BitValue,ColorMap]=bmpread(EnvironName);
VisitPlusEnviron=BitValue;

EnvironSize=size(BitValue);

RealEnviron=zeros(EnvironSize);

FreeColorInd=BitValue(1,1);
MarkColorIndex=256-FreeColorInd+1;   % in VisitPlusEnviron, mark the
               % position with INVERSE COLOR where the robot has allocated.

MapSize=floor(EnvironSize/MapGridWidth);

VisitTimes=zeros(MapSize);

TempPotentField=ones(MapSize(1),MapSize(2),AccumulateNum)*(-1);
TempPotentWeight=ones(MapSize(1),MapSize(2),AccumulateNum)*(-1);

for loop1=1:EnvironSize(1)
  for loop2=1:EnvironSize(2)
    if BitValue(loop1,loop2)==FreeColorInd
      RealEnviron(loop1,loop2)=FreeIndex;
    else
      RealEnviron(loop1,loop2)=ObstacleIndex;
    end
  end
end
     