function CheckStimulus=checkstimu(RobotRunList,SensingResult)
% CHECKSTIMU	Check the stimulus for the running robot.

%       Copyright (c) 1998-2000 Jiming Liu and Jianbing Wu

global EnvThresh RobotConfig RobotNum MapGridWidth;

[Careless,RunningNum]=size(RobotRunList);

CheckStimulus=zeros(2,RunningNum);

for loop1=1:RunningNum
  SelectedRobot=RobotRunList(loop1);

  TheSenseResult=SensingResult(:,SelectedRobot);

  InverseSense=1./TheSenseResult;
  [CheckStimulus(2,loop1),SumDistance]=sumattract(InverseSense);

  ThisConfig=RobotConfig(SelectedRobot,:);
  TotalRobotList=1:RobotNum;
  TotalRobotList(SelectedRobot)=[];
  SumEffectRobot=[0 0];
  for loop2=1:(RobotNum-1)
    ThatConfig=RobotConfig(TotalRobotList(loop2),:);
    [isInnerObstacle,TheDistance,TheDirection,ThisAngle]...
                 =testindirect(ThisConfig,ThatConfig);
    if ~isInnerObstacle & TheDistance<=EnvThresh*MapGridWidth
      SumEffectRobot=SumEffectRobot-robeffect(ThisConfig,ThatConfig);
    end
  end
  if all(SumEffectRobot==0)
    CheckStimulus(1,loop1)=0;
  else
    CheckStimulus(1,loop1)=getceil([-SumEffectRobot(1) SumEffectRobot(2)]);
  end
end
   