function [MoveableNum,MoveablePos]=moveablepos(RobotRunList)
% MOVEAVBLEPOS	Detect the moveable positions for robots.

%       Copyright (c) 1998-2000 Jiming Liu and Jianbing Wu

global RobotConfig MaxMoveStep SensorNum MapSize RealEnviron FreeIndex;
global MapGridWidth;

[Careless,RunningNum]=size(RobotRunList);

MoveableNum=zeros(RunningNum,SensorNum);
MoveablePos=[];

for mm=1:RunningNum
  WhichRobot=RobotRunList(mm);
  OldRobotConfig=RobotConfig(WhichRobot,:);

  RowUp=OldRobotConfig(1)- MaxMoveStep;
  if RowUp<=0
    RowUp=1;
  end
  RowDown=OldRobotConfig(1)+MaxMoveStep;
  if RowDown>MapSize(1)
    RowDown=MapSize(1);
  end

  ColLeft=OldRobotConfig(2)- MaxMoveStep;
  if ColLeft<=0
    ColLeft=1;
  end
  ColRight=OldRobotConfig(2)+MaxMoveStep;
  if ColRight>MapSize(2)
    ColRight=MapSize(2);
  end

  for loop1=RowUp:RowDown
    for loop2=ColLeft:ColRight
      [isInnerObstacle,TheDistance,TheDirection,ThisAngle]...
            =testindirect(OldRobotConfig,[loop1 loop2]);
      if ~isInnerObstacle & ...
         (RealEnviron(loop1*MapGridWidth,loop2*MapGridWidth)==FreeIndex)
        DeltaConfig=[loop1 loop2]-OldRobotConfig;
        TheDirection=getceil(DeltaConfig);
        MoveableNum(mm,TheDirection)=MoveableNum(mm,...
           TheDirection)+1;
        MoveablePos(mm,TheDirection,...
           MoveableNum(mm,TheDirection),1:2)=[loop1 loop2];
      end
    end
  end
end
