function [ySection,xSection]=robeffect(TheRobotConfig,UncovConfig)
% ROBEFFECT	Return the interaction between two robots.

%       Copyright (c) 1998-2000 Jiming Liu and Jianbing Wu

DeltaConfig=UncovConfig-TheRobotConfig;

TheDistance=sqrt(DeltaConfig(1)^2+DeltaConfig(2)^2);

ThisAngle=atan2(-DeltaConfig(1),DeltaConfig(2));

if TheDistance
  xSection=1/TheDistance*cos(ThisAngle);
  ySection=1/TheDistance*sin(ThisAngle);
else
  xSection=0;
  ySection=0;
end
