function chromosome=chrom_generat(RobotList,SingleBitLength,LastDirect,...
     CreateProbable,Population_Size,CurrentStimulus,BehaviorId)
% CHROM_GENERAT	Generate the population of chromosomes.

%       Copyright (c) 1998-2000 Jiming Liu and Jianbing Wu

global SensorNum;

[Careless,SectorNum]=size(RobotList);

LastBelief=0.4;
chromosome=[];

for loop1=1:SectorNum
  WhichRobot=RobotList(loop1);
  ThisStimulus=CurrentStimulus(:,loop1);
  if ThisStimulus(BehaviorId)
    OffsetDirect=ThisStimulus(BehaviorId);
    CorresponProb=CreateProbable(:,BehaviorId);
  else
    OffsetDirect=0;
    if BehaviorId==1
      CorresponProb=ones(SensorNum,1)/SensorNum;
    elseif BehaviorId==2
      if LastDirect(loop1)>0
        CorresponProb=ones(SensorNum,1)*(1-LastBelief)/(SensorNum-1);
        CorresponProb(LastDirect(loop1))=LastBelief;
      else
        CorresponProb=ones(SensorNum,1)/SensorNum;
      end
    end
  end

  SubChromosome=getsubchrom(CorresponProb,Population_Size,OffsetDirect,...
       SingleBitLength,WhichRobot);
  chromosome=[chromosome SubChromosome];
end
