function chrom1=cross_chrom(chrom,matenum,RobotRunList)
% CROSS_CHROM	'Crossover' operation in GAs.
%
%		TWO points CROSSOVER.

%       Copyright (c) 1998-2000 Jiming Liu and Jianbing Wu

mateind=[]; 
chrom1=chrom;
[pop bitlength]=size(chrom); 
ind=1:pop; 

u=floor(pop*matenum);
if floor(u/2)~=u/2
  u=u-1;
end
%select percentage to mate randomly

while length(mateind)~=u
  i=round(rand*pop);
  if i==0
    i=1;
  end
  if ind(i)~=-1
    mateind=[mateind i]; 
    ind(i)=-1;
  end
end

%perform single point crossover 

Loop=0;
for i=1:2:u-1
  Is_Legal=0;
  while ~Is_Legal
    Must_Again=0;
    while ~Must_Again
      splitpos=sort(floor(rand(1,2)*bitlength));  % crossover point
      for mm=1:2
        if splitpos(mm)==0
          splitpos(mm)=1; 
        end
      end
      if splitpos(1)~=splitpos(2)
        Must_Again=1;
      end
    end

    i1=mateind(i); 
    i2=mateind(i+1);
    tempgene=chrom(i1,splitpos(1)+1:splitpos(2));
    New_Chromosome1=chrom(i1,:);
    New_Chromosome2=chrom(i2,:);
    New_Chromosome1(splitpos(1)+1:splitpos(2))=chrom(i2,splitpos(1)+...
                   1:splitpos(2));
    New_Chromosome2(splitpos(1)+1:splitpos(2))=tempgene;
    Is_Legal=islegal_chrom(New_Chromosome1,RobotRunList);
    if Is_Legal
      Is_Legal=islegal_chrom(New_Chromosome2,RobotRunList);
    end
    if Is_Legal
      chrom1(i1,splitpos(1)+1:splitpos(2))=chrom(i2,splitpos(1)+1:...
               splitpos(2));
      chrom1(i2,splitpos(1)+1:splitpos(2))=tempgene;
    end

    Loop=Loop+1;           % avoid deadlock.
    if Loop>200
      break;
    end

  end
end
