function Fitness_Value=fitness1(chromosome,RobotRunList,CurrentStimulus,...
           ExistConfig,LastDirect)
% FITNESS1	Sample fitness function for GA.

%       Copyright (c) 1998-2000 Jiming Liu and Jianbing Wu

% ---- For Robot Cooperation ----
global EnvThresh MapGridWidth VisitedWeight;

CooperThresh=EnvThresh;
MinThresh=CooperThresh-1;

[ExistSize,Unuse]=size(ExistConfig);
[Careless,RunningNum]=size(RobotRunList);

[NewConfig,SelectDelta]=restoreconfig(RobotRunList,chromosome);

Fitness_Value=1;
% ------ COMMON Fit -------
for loop1=1:RunningNum
  for loop2=1:ExistSize
    ThisConfig=NewConfig(loop1,:);
    InPosConfig=ExistConfig(loop2,:);
    DeltaConfig=ThisConfig-InPosConfig;
    TheDistance=sqrt(DeltaConfig(1)^2+DeltaConfig(2)^2);
    [isInnerObstacle,ThisDistance,TheDirection,ThisAngle]...
          =testindirect(ThisConfig,InPosConfig);
    if isInnerObstacle
      Fitness_Value=Fitness_Value*4;
    else
      if TheDistance>MinThresh
        Fitness_Value=Fitness_Value*sqrt(sqrt(TheDistance-MinThresh));
      else
        Fitness_Value=Fitness_Value*0.001;
      end
    end
  end
  Fitness_Value=Fitness_Value*(1-VisitedWeight(NewConfig(1),NewConfig(2)));
end

% ------ PRIVATE Fit -------
for loop1=1:RunningNum-1
  for loop2=loop1:RunningNum
    ThisConfig=NewConfig(loop1,:);
    ThatConfig=NewConfig(loop2,:);
    DeltaConfig=ThisConfig-ThatConfig;
    TheDistance=sqrt(DeltaConfig(1)^2+DeltaConfig(2)^2);
    [isInnerObstacle,ThisDistance,TheDirection,ThisAngle]...
          =testindirect(ThisConfig,ThatConfig);
    if isInnerObstacle
      Fitness_Value=Fitness_Value*6;
    else 
      if TheDistance>CooperThresh
        Fitness_Value=Fitness_Value*sqrt(TheDistance-CooperThresh);
      else
        Fitness_Value=Fitness_Value*0.001;
      end
    end
  end
end
