function Fitness_Value=fitness2(chromosome,RobotRunList,CurrentStimulus,...
            ExistConfig,LastDirect)
% FITNESS2	Sample fitness function for GA.

%       Copyright (c) 1998-2000 Jiming Liu and Jianbing Wu

global EnvThresh MapGridWidth VisitedWeight MaxMoveStep MapSize SensorNum;
global SensorType RobotConfig;

UnitAngle=2*pi/SensorNum;

CooperThresh=EnvThresh;
MinThresh=CooperThresh-1;

[ExistSize,Unuse]=size(ExistConfig);
[Careless,RunningNum]=size(RobotRunList);

[NewConfig,SelectDelta]=restoreconfig(RobotRunList,chromosome);

Fitness_Value=1;
% ------ COMMON Fit -------
for loop1=1:RunningNum
  for loop2=1:ExistSize
    ThisConfig=NewConfig(loop1,:);
    InPosConfig=ExistConfig(loop2,:);
    DeltaConfig=ThisConfig-InPosConfig;
    TheDistance=sqrt(DeltaConfig(1)^2+DeltaConfig(2)^2);
    [isInnerObstacle,ThisDistance,TheDirection,ThisAngle]...
          =testindirect(ThisConfig,InPosConfig);
    if isInnerObstacle
      Fitness_Value=Fitness_Value*4;
    else
      if TheDistance>MinThresh
        Fitness_Value=Fitness_Value*sqrt(sqrt(TheDistance-MinThresh));
      else
        Fitness_Value=Fitness_Value*0.001;
      end
    end
  end
  Fitness_Value=Fitness_Value*(1-VisitedWeight(NewConfig(1),NewConfig(2)));
end

% ------ PRIVATE Fit -------

UncoverNum=0;
for loops=1:RunningNum
  WhichRobot=RobotRunList(loops);
  TheOldConfig=RobotConfig(WhichRobot,:);
  ThisNewConfig=NewConfig(loops,:);

  DeltaConfig=ThisNewConfig-TheOldConfig;
  CurrentStep=sqrt(DeltaConfig(1)^2+DeltaConfig(2)^2);
  ThisStepFit=2/(exp((CurrentStep-4)/4)+exp(-(CurrentStep-4)/4));

  TheInterval=getceil(DeltaConfig);
  LastMoveDirection=LastDirect(loops);
  if LastMoveDirection>0
    CosAngle=1.01+cos((TheInterval-LastMoveDirection)*UnitAngle);
  else
    CosAngle=1;
  end    

  for loop1=(ThisNewConfig(1)-MaxMoveStep):(ThisNewConfig(1)+MaxMoveStep)
    for loop2=(ThisNewConfig(2)-MaxMoveStep):(ThisNewConfig(2)+MaxMoveStep)
      if all([loop1 loop2]>0) & all([loop1 loop2]<=MapSize)
        if VisitedWeight(loop1,loop2)==0
          UncoverNum=UncoverNum+1;
        end
      end
    end
  end
  
  SensingResult=[];
  for loop1=1:SensorNum
    ReturnValue=testenv(ThisNewConfig,loop1);
    SensingResult=[SensingResult ReturnValue];
  end
  InverseSense=1./SensingResult;
  [NoUse,SumDistance]=sumattract(InverseSense);
  if ~SumDistance
    SumFit=1000;
  else
    SumFit=1/SumDistance;
  end
  
%  Fitness_Value=Fitness_Value*SumFit*ThisStepFit*CosAngle;
  Fitness_Value=Fitness_Value*SumFit*ThisStepFit;
end

Fitness_Value=Fitness_Value*UncoverNum;
