function [NewConfig,MoveDirection]=genmain(RobotRunList,CurrentStimulus,...
               ExistConfig,LastDirect,BehaviorId)
% GENMAIN	Main program for Genetic Algorithms operation.

%       Copyright (c) 1998-2000 Jiming Liu and Jianbing Wu

global SingleCodeWidth CrossProb MutationProb PopulationSize GenerationSize;
global DirectionWeight IncrementWeight SensorNum FitnessFun TotalWeight;

[Careless,RunningNum]=size(RobotRunList);

CurrentPopulatSize=PopulationSize(RunningNum);
CurrentGeneratSize=GenerationSize(RunningNum);

New_Population=chrom_generat(RobotRunList,SingleCodeWidth,LastDirect,...
     DirectionWeight,CurrentPopulatSize,CurrentStimulus,BehaviorId);

FirstMutateEnd=floor(CurrentGeneratSize/3);
SecondMutateEnd=floor(CurrentGeneratSize*2/3);

for loops=1:CurrentGeneratSize
  if loops<=FirstMutateEnd
    CurrentMutateProb=MutationProb(1);
  elseif loops<=SecondMutateEnd
    CurrentMutateProb=MutationProb(2); 
  else
    CurrentMutateProb=MutationProb(3); 
  end

  [Selected_Pop,isBreak,RandSelecChrom]=select_gen(...
        FitnessFun(BehaviorId,:),New_Population,ExistConfig,...
        RobotRunList,CurrentStimulus,CurrentPopulatSize,LastDirect);

  if isBreak
    Fittest_Chrom=Selected_Pop(1,:);
    break;
  else
    if ~isempty(Selected_Pop)
      Fittest_Chrom=RandSelecChrom;
    else
      Selected_Pop=chrom_generat(RobotRunList,SingleCodeWidth,LastDirect,...
           DirectionWeight,CurrentPopulatSize,CurrentStimulus,BehaviorId);
      TheRow=ceil(rand(1)*CurrentPopulatSize);
      Fittest_Chrom=Selected_Pop(TheRow,:);
    end
  end
  RemainChrom=Selected_Pop(1,:);

  Crossover_Pop=cross_chrom(Selected_Pop,CrossProb,RobotRunList);
  Mutate_Pop=mutate(Crossover_Pop,CurrentMutateProb,RobotRunList);
  Mutate_Pop(1,:)=[];
  New_Population=[RemainChrom;Mutate_Pop];
end
[NewConfig,AllDeltaConfig]=restoreconfig(RobotRunList,Fittest_Chrom);

MoveDirection=[];
for loop1=1:RunningNum
  WhichRobot=RobotRunList(loop1);
  ThisStimulus=CurrentStimulus(:,loop1);
  TheInterval=getceil(AllDeltaConfig(loop1,:));
  if BehaviorId==2
    MoveDirection=[MoveDirection TheInterval];
  else
    MoveDirection=[MoveDirection -1];
  end

  if ThisStimulus(BehaviorId)
    OffsetDirect=ThisStimulus(BehaviorId);
    CurrProb=DirectionWeight(:,BehaviorId);

    SelectedDirect=TheInterval-OffsetDirect+1;

    if SelectedDirect<=0
      SelectedDirect=SelectedDirect+SensorNum;
    end

    CurrProb(SelectedDirect)=CurrProb(SelectedDirect)+IncrementWeight;
    DirectionWeight(:,BehaviorId)=CurrProb/sum(CurrProb);

    Store=[BehaviorId DirectionWeight(:,BehaviorId)'];
    TotalWeight=[TotalWeight;Store];
  end
end
