function PotentTemp=getpotent
% GETPOTENT	Incremental self-organization calculation of potential field map.

%       Copyright (c) 1998-2000 Jiming Liu and Jianbing Wu

global TempPotentField TempPotentWeight MapSize AccumulateNum VisitedWeight;
global RealEnviron ObstacleIndex MapGridWidth;

PotentTemp=zeros(MapSize(1),MapSize(2));
VisitedWeight=ones(MapSize(1),MapSize(2))*(-1);

for loop1=1:MapSize(1)
  for loop2=1:MapSize(2)
    PotentCache=[];
    WeightCache=[];
    ModifyNum=0;
    for loopAccumulate=1:AccumulateNum
      if TempPotentField(loop1,loop2,loopAccumulate)~=-1
        PotentCache=[PotentCache TempPotentField(loop1,loop2,loopAccumulate)];
        WeightCache=[WeightCache ...
              TempPotentWeight(loop1,loop2,loopAccumulate)];
        ModifyNum=ModifyNum+1;
      else
        break;
      end
    end
    if ~isempty(PotentCache)
      [MaxWeight,WhichOne]=max(WeightCache);
      if MaxWeight==1
        PotentTemp(loop1,loop2)=PotentCache(WhichOne);
      else
        WeightCache=WeightCache/sum(WeightCache);
        PotentTemp(loop1,loop2)=PotentCache*WeightCache';
        PotentTemp(loop1,loop2)=mean(PotentCache);
      end
    end
    if isempty(WeightCache) & RealEnviron(loop1*MapGridWidth,...
         loop2*MapGridWidth)~=ObstacleIndex
      VisitedWeight(loop1,loop2)=0;
    elseif ~isempty(WeightCache)
      VisitedWeight(loop1,loop2)=MaxWeight;
    end    
  end
end

