function [isInnerObstacle,TheDistance,TheDirection,ThisAngle]...
                 =testindirect(BeginConfig,EndConfig)
% TESTINDIRECT	Detect the distance between two robots of different groups.

%       Copyright (c) 1998-2000 Jiming Liu and Jianbing Wu

global MapGridWidth RealEnviron EnvironSize FreeIndex ObstacleIndex;
global SensorNum;

RobotInEnvPos=BeginConfig*MapGridWidth;
DeltaConfig=EndConfig-BeginConfig;
TheDistance=sqrt(DeltaConfig(1)^2+DeltaConfig(2)^2)*MapGridWidth;

ThisAngle=atan2(-DeltaConfig(1),DeltaConfig(2));
TheDirection=getceil(DeltaConfig);

if all(BeginConfig==EndConfig)
  isInnerObstacle=0;
  SenseValue=0;
  return;
end

X_Robot=RobotInEnvPos(2);
Y_Robot=RobotInEnvPos(1);
Xstore=X_Robot;
Ystore=Y_Robot;     

isGOON=1;
isEdge=0;
isOBSTACLE=0;

while isGOON
  if abs(sin(ThisAngle))<=abs(cos(ThisAngle))
    xx=Xstore+sign(cos(ThisAngle));
    yy=round(Y_Robot-tan(ThisAngle)*(xx-X_Robot));
  else   
    yy=Ystore-sign(sin(ThisAngle));
    xx=round(X_Robot-cos(ThisAngle)*(yy-Y_Robot)/sin(ThisAngle));
  end
  if xx>EnvironSize(2) | xx<1 | yy>EnvironSize(1) | yy<1 
    isEdge=1;
    isGOON=0;
  else
    if RealEnviron(yy,xx) == ObstacleIndex
      isOBSTACLE=1;
      isGOON=0;
    else
      Xstore=xx;
      Ystore=yy;
    end
  end
end

SenseValue=sqrt((xx-X_Robot)^2+(yy-Y_Robot)^2);

if SenseValue<TheDistance
  isInnerObstacle=1;
else
  isInnerObstacle=0;
end
