function SenseValue=ultrason(WhichRobot,WhichSensor)
% ULTRASON	Simulating program for ultrasonic sensors.

%       Copyright (c) 1998-2000 Jiming Liu and Jianbing Wu

global SensorNum MapGridWidth RealEnviron EnvironSize RobotConfig;
global FreeIndex ObstacleIndex;

ThisConfig=RobotConfig(WhichRobot,:);
RobotInEnvPos=ThisConfig*MapGridWidth;

ThisAngle=2*pi*WhichSensor/SensorNum;

X_Robot=RobotInEnvPos(2);
Y_Robot=RobotInEnvPos(1);
Xstore=X_Robot;
Ystore=Y_Robot;     

isGOON=1;
isEdge=0;
isOBSTACLE=0;

while isGOON
  if abs(sin(ThisAngle))<=abs(cos(ThisAngle))
    xx=Xstore+sign(cos(ThisAngle));
    yy=round(Y_Robot-tan(ThisAngle)*(xx-X_Robot));
  else   
    yy=Ystore-sign(sin(ThisAngle));
    xx=round(X_Robot-cos(ThisAngle)*(yy-Y_Robot)/sin(ThisAngle));
  end
  if xx>EnvironSize(2) | xx<1 | yy>EnvironSize(1) | yy<1 
    isEdge=1;
    isGOON=0;
  else
    if RealEnviron(yy,xx) == ObstacleIndex
      isOBSTACLE=1;
      isGOON=0;
    else
      Xstore=xx;
      Ystore=yy;
    end
  end
end

%DirectDist=sqrt((Xstore-X_Robot)^2+(Ystore-Y_Robot)^2);
DirectDist=sqrt((xx-X_Robot)^2+(yy-Y_Robot)^2);

SenseValue=DirectDist;
