function callsom(SensingResult,SelectedRobot)
% CALLSOM	Calculate the potential field map for designated robot.

%       Copyright (c) 1998-2000 Jiming Liu and Jianbing Wu

global MapGridWidth MapSize SensorNum VisitTimes;
global PotentFunc RobotConfig MarkColorIndex VisitPlusEnviron;
global AccumulateNum TempPotentField TempPotentWeight;

ThisCoordinate=RobotConfig(SelectedRobot,:);
VisitTimes(ThisCoordinate(1),ThisCoordinate(2))=...
         VisitTimes(ThisCoordinate(1),ThisCoordinate(2))+1;
VisitPlusEnviron(ThisCoordinate(1)*MapGridWidth,...
         ThisCoordinate(2)*MapGridWidth)=MarkColorIndex;

Alpha=2*pi/SensorNum;

 for loop1=1:MapSize(1)
   for loop2=1:MapSize(2)
     CoordinateMatrix=[loop1 loop2];
     RadiusSize=sqrt((loop1-ThisCoordinate(1))^2+...
             (loop2-ThisCoordinate(2))^2); 

     RealRadius=RadiusSize*MapGridWidth;
     ThisSensingResult=[];
     Beta=atan2(-(loop1-ThisCoordinate(1)),loop2-ThisCoordinate(2));
     if Beta<0
       Beta=2*pi+Beta;
     end
     for mm=1:SensorNum
       CurrentSensing=SensingResult(mm)-RealRadius*cos(Alpha*mm-Beta);
       ThisSensingResult=[ThisSensingResult CurrentSensing];
     end
     NewPotent=comp_pot(ThisSensingResult,SensorNum,PotentFunc);
 
     if NewPotent>0
       for loopAccumulate=1:AccumulateNum
         if TempPotentField(CoordinateMatrix(1),CoordinateMatrix(2),...
                     loopAccumulate)==-1
           TempPotentField(CoordinateMatrix(1),CoordinateMatrix(2),...
               loopAccumulate)=NewPotent;
           TempPotentWeight(CoordinateMatrix(1),CoordinateMatrix(2),...
               loopAccumulate)=exp(-RadiusSize^2/600);
           break;
         end
       end         
     end
  end
end
