function drawing(Dir_Name)
% DRAWING	Draw the experimental results.

%     Copyright (c) 1996-2000 Jiming Liu and Jianbing Wu

% Case=1: plot the HISTogram-time of different STIMULUS and corresponding 
%         Loop_Weight of the CLASS1.
%% Case=2: plot the HISTogram-time of different STIMULUS and corresponding 
%         Loop_Weight of the CLASS2 .
% Case=3: plot the Macro-distance of the RR, RW, WW.
% Case=4: plot the BAR graphics of Response_Id-Time.

close all;

if nargin~=1
  disp(' Wrong number of Imported Arguments.');
  return;
else
  % ------- Enter RESULT sub-directory ------
  cd ..;
  cd result;
  fid=fopen(Dir_Name);
  if fid<0
    disp(' Error Enter assigned Directory.');
    disp(' Please check the current directory.');
    cd ..;
    cd drawing;
    return;
  end
  fclose(fid);
  eval(['cd ' Dir_Name ';']);

  % --------- Create FileName ----------
  [Is_Dash,Pos]=is_dash(Dir_Name);
  if Is_Dash
    File_Segment=Dir_Name(1:(Pos-1));
  else
    File_Segment=Dir_Name;
  end

  % ------------  Access  --------------
 
  FLname=[File_Segment '_info'];
  eval(['load ' FLname ';']);
  clear Public_Str Is_Dash Dir_Name fid;
 
  History_Size=size(HISTORY);
  Max_Age=HISTORY(History_Size(1),3);

  Red_Num=get_cell_num(1,CLASS,Cell_Num_Pos,Class_Matrix_Size);
  White_Num=get_cell_num(2,CLASS,Cell_Num_Pos,Class_Matrix_Size);

 % figure('Position',[100 100 450 640]);
         
  Fig_Title=['Case: ' File_Segment];

  xx=1:Max_Age;

for Case=1:3
  if Case==1
    FLname=[File_Segment '_Stim_Ind'];
    eval(['load ' FLname ';']);
  
    FLname=[File_Segment '_Stim_Hist'];
    eval(['load ' FLname ';']);

    FLname=[File_Segment '_Lp_Wet'];
    eval(['load ' FLname ';']);

    Index_Size=size(Stimulus_Index);
    for mm=1:Index_Size(1)
      if Stimulus_Index(mm,3)<0   
        Stimulus_Index(mm,3)=0;
      end
    end 

    Stimulus_Num=Index_Size(1)/Stimulus_Size(1);
    for  mm=1:Stimulus_Num
      clg;
          %  plot the HISTogram first
      yy1=(Stimulus_Counter(:,mm))';
      Begin_Col=(mm-1)*Stimulus_Size(1)+1;
      End_Col=Begin_Col+Stimulus_Size(1)-1;
      yy2=(LoopEnd_Behavior(:,Begin_Col:End_Col))';
      yy3=Stimulus_Index(Begin_Col:End_Col,:);

      for nn=1:Max_Age
        if all(yy2(:,nn)==0)
           yy2(:,nn)=NaN*ones(Stimulus_Size(1),1);
        end
      end

      axes('position',[0.1 0.89 0.85 0.1]);
      axis off;                          

      Cls=yy3(1,1);                      
      Class_Str=['Cls: ' int2str(Cls)];  
      Stimulus_Str=['Stimu: ' sprintf('%d',(yy3(:,3))')];
      Total_Stimulus=['Total_Stimu: ' int2str(Stimulus_Num)];
      First_Line=[Class_Str '          ' Stimulus_Str '        ' ...
                  Total_Stimulus];

      axis([0 100 0 100]);               
      text(0,70,Fig_Title);
      text(0,25,First_Line);             

      axes('position',[0.1 0.53 0.85 0.35]);
      plot(xx,yy1);
      axis([1 400 0 Red_Num]);
      grid on;
      xlabel('t');
      ylabel('Stimuli Hist');

      axes('position',[0.1 0.09 0.85 0.35]);
      for kk=1:Stimulus_Size(1)
        Y_Vector=yy2(kk,:)+(kk-1);

        plot(xx,Y_Vector);
        grid on;
        hold on;
      end
      axis([1 Max_Age 0 White_Num]);
      xlabel('t');
      ylabel('weight');
      hold off;

      PsFileName=['hist_wet' '_p' int2str(mm)];
      eval(['print ' PsFileName ' -dps' ';']);  
%      pause(1);
      Key_Str=input('input:','s');
      if Key_Str=='y' | Key_Str=='Y'
        eval(['!lpps -h ' PsFileName '.ps' ';']);
      end
    end

  elseif Case==2
    FLname=[File_Segment '_RR_Macro'];
    eval(['load ' FLname ';']);

    FLname=[File_Segment '_RW_Macro'];
    eval(['load ' FLname ';']);

    FLname=[File_Segment '_WW_Macro'];
    eval(['load ' FLname ';']);

    RR_Value=Red_Num*(Red_Num-1)/2;
    RW_Value=Red_Num*White_Num;
    WW_Value=White_Num*(White_Num-1)/2;
    
    RR_Macro_Distance=RR_Macro_Distance/RR_Value;
    RW_Macro_Distance=RW_Macro_Distance/RW_Value;
    WW_Macro_Distance=WW_Macro_Distance/WW_Value;

    for mm=1:3
      if mm==1
        File_Str='rr';
        Text_Title='RR_Distance';
        Distance_Matrix=RR_Macro_Distance';
      elseif mm==2
        File_Str='rw';
        Text_Title='RW_Distance';
        Distance_Matrix=RW_Macro_Distance';
      elseif mm==3
        File_Str='ww';
        Text_Title='WW_Distance';
        Distance_Matrix=WW_Macro_Distance';
      end

      clg;

      First_Line=['Subject: ' Text_Title];

      axes('position',[0.1 0.89 0.85 0.1]);
      axis off;
      axis([0 100 0 100]);
      text(0,70,Fig_Title);
      text(0,30,First_Line);

      axes('position',[0.1 0.1 0.85 0.8]);
      for kk=1:11
        Y_Vector=Distance_Matrix(kk,:)+(kk-1);
        plot(xx,Y_Vector);
        grid on;
        hold on;
      end
      axis([1 Max_Age 0 11]);
      xlabel('t');
      ylabel('Macro-Distance');
      hold off;
     
      PsFileName=['macro_' File_Str]; 
      eval(['print ' PsFileName ' -dps' ';']);
      eval(['!lpps -h ' PsFileName '.ps' ';']);
      pause(1);
    end

  elseif Case==3
    FLname=[File_Segment '_R_RespId'];
    eval(['load ' FLname ';']);

    FLname=[File_Segment '_W_RespId'];
    eval(['load ' FLname ';']);

    Red_Id=zeros(Stimulus_Size(1),Max_Age);
    White_Id=zeros(Stimulus_Size(1),Max_Age);

    Red_Size=size(Red_ResponseId);
    White_Size=size(White_ResponseId);

    for mm=1:Max_Age
      for nn=1:Red_Size(2)
        if Red_ResponseId(mm,nn)~=0
          Id=Red_ResponseId(mm,nn);
          Red_Id(Id,mm)=Red_Id(Id,mm)+1/Red_Num;
        end
      end
      if all(Red_Id(:,mm)==0)
        Red_Id(:,mm)=NaN*ones(Stimulus_Size(1),1);
      end

      for nn=1:White_Size(2)
        if White_ResponseId(mm,nn)~=0
          Id=White_ResponseId(mm,nn);         
          White_Id(Id,mm)=White_Id(Id,mm)+1/White_Num;
        end
      end
      if all(White_Id(:,mm)==0)
        White_Id(:,mm)=NaN*ones(Stimulus_Size(1),1);
      end
    end

    for mm=1:2
      if mm==1
        File_Str='rid';
        Text_Title='Red Response_Id';
        Id_Matrix=Red_Id;
      elseif mm==2
        File_Str='wid';
        Text_Title='White Response_Id';
        Id_Matrix=White_Id;
      end

      clg;

      First_Line=['Subject: ' Text_Title];

      axes('position',[0.1 0.89 0.85 0.1]);
      axis off;
      axis([0 100 0 100]);
      text(0,70,Fig_Title);
      text(0,30,First_Line);

      axes('position',[0.1 0.1 0.85 0.8]);
      for kk=1:Stimulus_Size(1)
        Y_Vector=Id_Matrix(kk,:)+(kk-1);
        plot(xx,Y_Vector);
        grid on;
        hold on;
      end
      axis([1 Max_Age 0 Stimulus_Size(1)]);
      xlabel('t');
      ylabel('Response_Id');
      hold off;

      PsFileName=['response_' File_Str];
      eval(['print ' PsFileName ' -dps' ';']);
      if mm==1
        eval(['!lpps -h ' PsFileName '.ps' ';']);
      end
      pause(1);
    
    end
  end  
end
  % go back to DIRECTORY:/drawing/ 
  cd ..;
  cd ..;
  cd drawing;
end
close all;
clear all;