function historyview_menu(fig)
% HITORYVIEW_MENU	Control menu in history showing window.

%     Copyright (c) 1996-2000 Jiming Liu and Jianbing Wu

uicontrol(fig,...
        'Style','frame',...
        'Units','pixels',...
        'Position',[16 6 513 58],...
        'BackgroundColor',[0.7 0.7 0.7]);

uicontrol(fig,...      
        'Style','frame',...      
        'Units','pixels',...          
        'Position',[23 13 499 44],...  
        'BackgroundColor',[1 1 1]);      

uicontrol(fig,...      
        'Style','frame',...      
        'Units','pixels',...          
        'Position',[506 6 78 58],...  
        'BackgroundColor',[0.7 0.7 0.7]);   

uicontrol(fig,...      
        'Style','frame',...
        'Units','pixels',...
        'Position',[513 13 64 44],...
        'BackgroundColor',[1 1 1]);      

uicontrol(fig,...
        'Style','frame',...
        'Units','pixels',...
        'Position',[506 56 78 376],... 
        'BackgroundColor',[0.7 0.7 0.7]);

uicontrol(fig,...
        'Style','frame',...
        'Units','pixels',...
        'Position',[513 63 64 362],...
        'BackgroundColor',[1 1 1]);

ViewMore_Callback=[...
        'UserData_History=get(gcf,''UserData'');',...
        'Point_X=UserData_History(1);',...
        'Point_Y=UserData_History(2);',...
        'View_Width=UserData_History(3);',...
        'Point_X=Point_X-View_Width/2;',...
        'Point_Y=Point_Y-View_Width/2;',...
        'View_Width=View_Width*2;',...
        'UserData_History(1)=Point_X;',...
        'UserData_History(2)=Point_Y;',...  
        'UserData_History(3)=View_Width;',...  
        'set(gcf,''UserData'',UserData_History);',...
        'set(UserData_History(12),''Enable'',''on'');',...
        'plot_history;'];

ViewMore_Hndl=uicontrol(fig,...
                'Style','pushbutton',...
                'Units','pixels',...
                'Position',[30 20 50 30],...
                'String','+',...
                'Callback',ViewMore_Callback);

ViewLess_Callback=[...
        'UserData_History=get(gcf,''UserData'');',...
        'Point_X=UserData_History(1);',...
        'Point_Y=UserData_History(2);',...
        'View_Width=UserData_History(3);',...
        'if View_Width>10,',...
          'Point_X=Point_X+View_Width/4;',...
          'Point_Y=Point_Y+View_Width/4;',...
          'View_Width=View_Width/2;',...
          'UserData_History(1)=Point_X;',...
          'UserData_History(2)=Point_Y;',...
          'UserData_History(3)=View_Width;',...
          'set(gcf,''UserData'',UserData_History);',...
          'plot_history;',...
          'if View_Width<=10,',...
             'set(UserData_History(12),''Enable'',''off'');',...
          'end,',...
        'end'];

ViewLess_Hndl=uicontrol(fig,...
                'Style','pushbutton',...
                'Units','pixels',...
                'Position',[105 20 50 30],...
                'String','-',...
                'Enable','off',...
                'Callback',ViewLess_Callback);

ViewUp_Callback=[...
        'UserData_History=get(gcf,''UserData'');',...
        'Point_X=UserData_History(1);',...
        'Point_Y=UserData_History(2);',...
        'View_Width=UserData_History(3);',...
        'Point_Y=Point_Y+View_Width;',...
        'UserData_History(2)=Point_Y;',...
        'set(gcf,''UserData'',UserData_History);',...
        'plot_history;'];

ViewUp_Hndl=uicontrol(fig,...
                'Style','pushbutton',...
                'Units','pixels',...
                'Position',[205 20 50 30],...
                'String','UP',...
                'Callback',ViewUp_Callback);

ViewDown_Callback=[...
        'UserData_History=get(gcf,''UserData'');',...
        'Point_X=UserData_History(1);',...
        'Point_Y=UserData_History(2);',...
        'View_Width=UserData_History(3);',...
        'Point_Y=Point_Y-View_Width;',...  
        'UserData_History(2)=Point_Y;',...
        'set(gcf,''UserData'',UserData_History);',...
        'plot_history;'];                 

ViewDown_Hndl=uicontrol(fig,...
                'Style','pushbutton',...
                'Units','pixels',...
                'Position',[280 20 50 30],...
                'String','DOWN',...
                'Callback',ViewDown_Callback);

ViewLeft_Callback=[...
        'UserData_History=get(gcf,''UserData'');',...
        'Point_X=UserData_History(1);',...
        'Point_Y=UserData_History(2);',...
        'View_Width=UserData_History(3);',...
        'Point_X=Point_X-View_Width;',...
        'UserData_History(1)=Point_X;',...
        'set(gcf,''UserData'',UserData_History);',...
        'plot_history;'];

ViewLeft_Hndl=uicontrol(fig,...
                'Style','pushbutton',...
                'Units','pixels',...
                'Position',[355 20 50 30],...
                'String','LEFT',...
                'Callback',ViewLeft_Callback);

ViewRight_Callback=[...
        'UserData_History=get(gcf,''UserData'');',...
        'Point_X=UserData_History(1);',...
        'Point_Y=UserData_History(2);',...
        'View_Width=UserData_History(3);',...
        'Point_X=Point_X+View_Width;',...
        'UserData_History(1)=Point_X;',...
        'set(gcf,''UserData'',UserData_History);',...
        'plot_history;'];

ViewRight_Hndl=uicontrol(fig,...
                'Style','pushbutton',...
                'Units','pixels',...
                'Position',[430 20 50 30],...
                'String','RIGHT',...
                'Callback',ViewRight_Callback);

ViewStart_Hndl=uicontrol(fig,...  
                'Style','pushbutton',...
                'Units','pixels',...
                'Position',[520 360 50 30],...
                'String','START',...
                'Interruptible','yes',...
                'Callback','start_show_history;');

Again_Callback=[...
        'Is_Pause=0;',...
        'UserData_History=get(gcf,''UserData'');',...
        'UserData_History(5)=0;',...  
        'UserData_History(4)=0;',...  
        'set(gcf,''UserData'',UserData_History);',...
        'plot_history;',...
        'start_show_history;'];

ViewAgain_Hndl=uicontrol(fig,...  
                'Style','pushbutton',...
                'Units','pixels',...
                'Position',[520 300 50 30],...
                'Enable','off',...
                'Interruptible','yes',...
                'String','AGAIN',...
                'Callback',Again_Callback);

Pause_Callback=[...
        'UserData_History=get(gcf,''UserData'');',...
        'UserData_History(5)=1;',...
        'set(gcf,''UserData'',UserData_History);'];           

ViewPause_Hndl=uicontrol(fig,...
                'Style','pushbutton',...
                'Units','pixels',...
                'Position',[520 230 50 30],...
                'Enable','off',...
                'String','PAUSE',...
                'Callback',Pause_Callback);

Goon_Callback=[...
        'Is_Pause=0;',...
        'UserData_History=get(gcf,''UserData'');',...
        'UserData_History(5)=Is_Pause;',...
        'set(gcf,''UserData'',UserData_History);',...
        'start_show_history;'];

ViewGoon_Hndl=uicontrol(fig,...
                'Style','pushbutton',...
                'Units','pixels',...
                'Position',[520 170 50 30],...
                'Enable','off',...
                'Interruptible','yes',...
                'String','GO ON',...
                'Callback',Goon_Callback);

Close_Callback=[...
         'close(gcf);',...
         'clear all;'];

ViewClose_Hndl=uicontrol(fig,...
                'Style','pushbutton',...
                'Units','pixels',...
                'Position',[520 100 50 30],...
                'String','CLOSE',...
                'Callback',Close_Callback);

ViewPoint_Hndl=uicontrol(fig,...
                'Style','text',...
                'BackGroundColor',[1 1 1],...
                'Units','pixels',...
                'Position',[520 20 50 30],...
                'String','0');

UserData_History=get(fig,'UserData');

UserData_History(11)=ViewMore_Hndl;
UserData_History(12)=ViewLess_Hndl;
UserData_History(13)=ViewUp_Hndl;
UserData_History(14)=ViewDown_Hndl;
UserData_History(15)=ViewLeft_Hndl;
UserData_History(16)=ViewRight_Hndl;
UserData_History(17)=ViewPoint_Hndl;
UserData_History(18)=ViewStart_Hndl;
UserData_History(19)=ViewAgain_Hndl;
UserData_History(20)=ViewPause_Hndl;
UserData_History(21)=ViewGoon_Hndl;
UserData_History(22)=ViewClose_Hndl;

set(fig,'UserData',UserData_History);
