function plot_history
% PLOT_HISTORY	Draw the cell form HISTORY age by age.

%     Copyright (c) 1996-2000 Jiming Liu and Jianbing Wu

UserData_History=get(gcf,'UserData');

Point_X=UserData_History(1);
Point_Y=UserData_History(2);
View_Width=UserData_History(3);

cla;
End_X=Point_X+View_Width;
End_Y=Point_Y+View_Width;
axis([Point_X,End_X,Point_Y,End_Y]);
axis on;

hold on;

Age=UserData_History(4);

uicontrol(gcf,...         
      'Style','text',...  
      'Units','pixels',...
      'BackGroundColor',[1 1 1],...
      'Position',[520 20 50 30],...
      'String',num2str(Age));

HISTORY_Matrix=get(UserData_History(18),'UserData');

Begin_Row=get_age_row(HISTORY_Matrix,Age);

History_Size=size(HISTORY_Matrix);

for mm=Begin_Row:History_Size(1)
  if HISTORY_Matrix(mm,3)==Age
    Class_Id=HISTORY_Matrix(mm,1);
    LocationX=HISTORY_Matrix(mm,4);
    LocationY=HISTORY_Matrix(mm,5);
    if LocationX<=End_X & LocationX>=Point_X ...
         & LocationY<=End_Y & LocationY>=Point_Y
      Cell_Color=get_cell_color(Class_Id);
      plot(LocationX,LocationY,'LineStyle','.','Color',Cell_Color,...
                 'erasemode','xor','markersize',200/View_Width);
    end
  else
    return;
  end
  drawnow;
end

uicontrol(gcf,...
      'Style','text',...
      'Units','pixels',...
      'BackGroundColor',[1 1 1],...
      'Position',[520 20 50 30],...
      'String',num2str(Age));
drawnow;
