function view_spline(Dir_Name,Age,Before)
% VIEW_SPLINE	Plot the spline trajectory of classes of robots.

%     Copyright (c) 1996-2000 Jiming Liu and Jianbing Wu

close all;

  % --------- Create FileName ----------
  [Is_Dash,Pos]=is_dash(Dir_Name);   
  if Is_Dash
    File_Segment=Dir_Name(1:(Pos-1));
  else
    File_Segment=Dir_Name;
  end

  % ------- Enter RESULT sub-directory ------
  cd ..;
  cd result;
  fid=fopen(Dir_Name);
  if fid<0
    disp(' Error Enter assigned Directory.');
    disp(' Please check the current directory.');
    cd ..;
    cd drawing;
    return;
  end
  fclose(fid);
  eval(['cd ' Dir_Name ';']);

  FLname=[File_Segment '_info'];
  eval(['load ' FLname ';']);
  clear Public_Str Is_Dash Dir_Name fid;

  cd ..;
  cd ..;
  cd drawing;

  Point_X=0;
  Point_Y=0;
  View_Width=10;

  figHistory=figure(...
                'Color',[0 0 0],...
                'Position',[300 200 600 450],...
                'Resize','off',...
                'NumberTitle','off',...
                'Name','Distribution Show');

  End_X=Point_X+View_Width;
  End_Y=Point_Y+View_Width;

  History_Size=size(HISTORY);
  Max_Age=HISTORY(History_Size(1),3);

  if Age<=0 | Age>Max_Age
    disp('Error Age');
    return;
  else
    clg;                     

    axes('position',[0.1 0.08 0.8 0.8]);
    plot(Point_X,Point_Y,'color',[1 1 1]);
    axis([Point_X,End_X,Point_Y,End_Y]);
    axis on;                 
    hold on;                 


    Begin_Row=get_age_row(HISTORY,Age);
    if Age==Max_Age
      End_Row=History_Size(1);
    else
      End_Row=get_age_row(HISTORY,Age+1)-1;
    end
 
    for mm=Begin_Row:End_Row
      Class_Id=HISTORY(mm,1);
      LocationX=HISTORY(mm,4);
      LocationY=HISTORY(mm,5);
      if Class_Id==1
        Line_Style='*';
        Mark_Size=60/View_Width;
      elseif Class_Id==2
        Line_Style='.';
        Mark_Size=200/View_Width;
      end      
      if LocationX<=End_X & LocationX>=Point_X ...
         & LocationY<=End_Y & LocationY>=Point_Y
        Cell_Color=get_cell_color(Class_Id);
        plot(LocationX,LocationY,'LineStyle',Line_Style,'Color',Cell_Color,...
                 'erasemode','xor','markersize',Mark_Size);

        Cel=HISTORY(mm,2);
        Num=0;
        X_Vector=[];
        Y_Vector=[];
        for nn=Before:-1:1
          if Age-nn>=1
            Last_Config=get_history_config(HISTORY,Class_Id,Cel,Age-nn);
            Last_X=Last_Config(1);
            Last_Y=Last_Config(2);
            X_Vector=[X_Vector Last_X];
            Y_Vector=[Y_Vector Last_Y];
            Num=Num+1;
          end
        end    
        X_Vector=[X_Vector LocationX];
        Y_Vector=[Y_Vector LocationY];  
        t=1:(Num+1);
        ts=1:0.1:(Num+1);
        xs=spline(t,X_Vector,ts);
        ys=spline(t,Y_Vector,ts);
        plot(xs,ys,'Color',Cell_Color);
%    'LineStyle','--');
      end
    end

    axes('position',[0.1 0.89 0.8 0.1]);
    axis off;
    axis([0 100 0 100]);
    Fig_Title=['Case: ' File_Segment];
    First_Line=['Step: ' int2str(Age) '      Steps of Spline: ' int2str(Num)];
    text(0,70,Fig_Title);
    text(0,30,First_Line);
  end
