function calculate
% CALCULATE	Operate the main computation for multiagent
%
%		reinforcement learning.

%     Copyright (c) 1996-2000 Jiming Liu and Jianbing Wu

global Class_Id_Vector CELL Region_Num Stimulus_Size HISTORY;
global Stimulus_Counter Response_Weight LoopEnd_Behavior; 
global RR_Macro_Distance RW_Macro_Distance WW_Macro_Distance;

Total_Class_Num=size(Class_Id_Vector);

Counter_Size=size(Stimulus_Counter);
Ext_Vector=zeros(1,Counter_Size(2));          
Stimulus_Counter=[Stimulus_Counter;Ext_Vector];

%Ext_Vector=zeros(1,11);
%RR_Macro_Distance=[RR_Macro_Distance;Ext_Vector];
%RW_Macro_Distance=[RW_Macro_Distance;Ext_Vector];
%WW_Macro_Distance=[WW_Macro_Distance;Ext_Vector];

for Cls=1:Total_Class_Num(2)
  Class_Id=Class_Id_Vector(Cls);
    Cell_Num_Loop=get_cell_num(Class_Id);
    for Cel_Count=1:Cell_Num_Loop  

      Begin_Row=get_begin_row(CELL,Class_Id);
      Cel=CELL(Begin_Row+Cel_Count-1,2);
      [Cell_Density,Sensing_Radius,Is_In_Origin]=...
            test_density(Class_Id,Cel,Region_Num);
      
      if ~Is_In_Origin
        [Response_Id,STIMULUS,Region_Id,Exist_Response,Response_Vect]...
               =select_response(Class_Id,Region_Num,Cell_Density);
      else
        [Response_Id,STIMULUS,Region_Id,Exist_Response,Response_Vect]=...
           get_inrad_response(Class_Id,Region_Num,Cell_Density);
      end

        [New_Config,Current_Config,New_Age]=follow_response(Class_Id,...
             Cel,Region_Id,Sensing_Radius,Cell_Density,Response_Id);

        perform_system_eval(Class_Id,Cel,Cell_Density,...
               Sensing_Radius,Exist_Response,Response_Id,STIMULUS,...
                     Response_Vect,Is_In_Origin,New_Age);
          
    end 
end

%plot_cell;

% Below is to create VARIABLES Matrix.

Response_Wet_Size=size(Response_Weight);
Behavior_Size=size(LoopEnd_Behavior);
Weight_Vector=(Response_Weight(:,Response_Wet_Size(2)))';
if Behavior_Size(1)==0
  LoopEnd_Behavior=Weight_Vector;
elseif Response_Wet_Size(1)>Behavior_Size(2)
  LoopEnd_Behavior(Behavior_Size(1),Response_Wet_Size(1))=0;
  LoopEnd_Behavior=[LoopEnd_Behavior;Weight_Vector];
elseif Response_Wet_Size(1)<=Behavior_Size(2)
  LoopEnd_Behavior=[LoopEnd_Behavior;Weight_Vector];
end   

%HISTORY_Size=size(HISTORY);
%Age_Now=HISTORY(HISTORY_Size(1),3);
%Row_Number=get_age_row(HISTORY,Age_Now);
%Config_Now=HISTORY(Row_Number:HISTORY_Size(1),4:5);
%Red_CellNum=get_cell_num(1);
%White_CellNum=get_cell_num(2);
%for mm=1:Red_CellNum
%  Self_Config=Config_Now(mm,:);
%  for nn=(mm+1):Red_CellNum
%    Desti_Config=Config_Now(nn,:);
%    dist=sqrt((Self_Config(1)-Desti_Config(1))^2+...
%             (Self_Config(2)-Desti_Config(2))^2);
%    Col=ceil(dist);
%    if Col>11
%      Col=11;
%    end
%    RR_Macro_Distance(Age_Now,Col)=RR_Macro_Distance(Age_Now,Col)+1;
%  end
%end

%for mm=1:Red_CellNum
%  Self_Config=Config_Now(mm,:);
%  for nn=(Red_CellNum+1):(Red_CellNum+White_CellNum)
%    Desti_Config=Config_Now(nn,:);
%    dist=sqrt((Self_Config(1)-Desti_Config(1))^2+...
%             (Self_Config(2)-Desti_Config(2))^2);
%    Col=ceil(dist);
%    if Col>11
%      Col=11;
%    end
%    RW_Macro_Distance(Age_Now,Col)=RW_Macro_Distance(Age_Now,Col)+1;
%  end
%end

%for mm=(Red_CellNum+1):(Red_CellNum+White_CellNum)
%  Self_Config=Config_Now(mm,:);
%  for nn=(mm+1):(Red_CellNum+White_CellNum)
%    Desti_Config=Config_Now(nn,:);
%    dist=sqrt((Self_Config(1)-Desti_Config(1))^2+...
%             (Self_Config(2)-Desti_Config(2))^2);
%    Col=ceil(dist);
%    if Col>11
%      Col=11;
%    end
%    WW_Macro_Distance(Age_Now,Col)=WW_Macro_Distance(Age_Now,Col)+1;
%  end
%end

