function [New_Config,Current_Config,Step]=execute_response(Class_Id,...
              Region_Id,Cel,Sensing_Radius,Cell_Density)
% EXECUTE_RESPONSE	Execute the selected response.                 

%     Copyright (c) 1996-2000 Jiming Liu and Jianbing Wu

global Region_Num Sensing_Step_Ratio Region_Max;
%global Distribute_Now;

  % get current configuration of the cell.
Current_Config = get_cell_config(Class_Id,Cel);

New_Config=zeros(1,2);

if Region_Id==0
  New_Config=Current_Config;
  Step=0;
else
  Alpha=2*pi/Region_Num;

  Step1=Sensing_Radius*Sensing_Step_Ratio;
% Step1 : the step based on the Sensing_Radius

  Step=step_by_mindist(Class_Id,Cel,Region_Id,Current_Config(1),...
                  Current_Config(2),Step1);

  New_Config(1)=Current_Config(1)+Step*cos((Region_Id-0.5)*Alpha);
  New_Config(2)=Current_Config(2)+Step*sin((Region_Id-0.5)*Alpha);

 % --- Operation to the case of Distribution (Edge/no)
 % Region_Max: maximum of the moving range

%  if Distribute_Now==2 | Distribute_Now==4
%    if New_Config(1)>Region_Max
%      New_Config(1)=Region_Max;
%    elseif New_Config(1)<0
%      New_Config(1)=0;
%    end
%    if New_Config(2)>Region_Max
%      New_Config(2)=Region_Max;
%    elseif New_Config(2)<0
%      New_Config(2)=0;
%    end
%  end
end
 