function perform_system_eval(Class_Id,Cel,...
         Cell_Density,Sensing_Radius,Exist_Response,Response_Id,STIMULUS,...
         Response_Vect,Is_In_Origin,New_Age)
% PERFORM_SYSTEM_EVAL	System performance evaluation for seleted response.

%     Copyright (c) 1996-2000 Jiming Liu and Jianbing Wu

global Response_Weight CELL Stimulus_Index Stimulus_Counter;
global Increment_Now;

if Response_Id~=0
  Sum_White=sum(Cell_Density(2,:));
  Sum_Red=sum(Cell_Density(1,:));

  Current_Config=get_cell_config(Class_Id,Cel);
  Xself=Current_Config(1);
  Yself=Current_Config(2);
  Cell_Size=size(CELL);

  New_Sum_White=0;
  New_Sum_Red=0;

  for mm=1:Cell_Size(1)
    if CELL(mm,1)~=Class_Id | CELL(mm,2)~=Cel
      Xother=CELL(mm,3);
      Yother=CELL(mm,4);
      dist=sqrt((Xself-Xother)^2+(Yself-Yother)^2);
      if dist<=Sensing_Radius
        if CELL(mm,1)~=Class_Id
          New_Sum_White=New_Sum_White+1;
        elseif CELL(mm,1)==Class_Id
          New_Sum_Red=New_Sum_Red+1;
        end
      end
    end
  end

% ----- Increment ------
  if Increment_Now==1
    Increment_Vector=[0.1 0.2];
  elseif Increment_Now==2
    Increment_Vector=[0.2 0.3];
  elseif Increment_Now==3
    Increment_Vector=[0.3 0.4];
  elseif Increment_Now==4
    Increment_Vector=[0.4 0.5];
  end


  if Class_Id==1 & ~Is_In_Origin
    if New_Sum_White>Sum_White 
      New_Behavior_Para=modify_behavior_par(Response_Vect,Response_Id,...
                   1,Increment_Vector(1));
    elseif New_Sum_White<Sum_White 
      New_Behavior_Para=modify_behavior_par(Response_Vect,Response_Id,...
                  -1,Increment_Vector(1));
    elseif New_Sum_White==Sum_White 
      New_Behavior_Para=Response_Vect;
    end
  elseif Class_Id==1 & Is_In_Origin
    if New_Sum_White>=Sum_White & New_Sum_Red<Sum_Red
      New_Behavior_Para=modify_behavior_par(Response_Vect,Response_Id,...
                   1,Increment_Vector(2));
    elseif New_Sum_White>=Sum_White & New_Sum_Red>=Sum_Red 
      New_Behavior_Para=modify_behavior_par(Response_Vect,Response_Id,...
                   1,Increment_Vector(2)/2);
    elseif New_Sum_White<Sum_White & New_Sum_Red<Sum_Red 
      New_Behavior_Para=modify_behavior_par(Response_Vect,Response_Id,...
                  -1,Increment_Vector(2)/2);
    elseif New_Sum_White<Sum_White & New_Sum_Red>=Sum_Red 
      New_Behavior_Para=modify_behavior_par(Response_Vect,Response_Id,...
                  -1,Increment_Vector(2));
    end
  elseif Class_Id==2
    if New_Sum_Red<Sum_Red
      New_Behavior_Para=modify_behavior_par(Response_Vect,Response_Id,...
                   1,Increment_Vector(1));
    elseif New_Sum_Red==Sum_Red
      New_Behavior_Para=Response_Vect;
    elseif New_Sum_Red>Sum_Red
      New_Behavior_Para=modify_behavior_par(Response_Vect,Response_Id,...
                  -1,Increment_Vector(1));
    end
  end
else
  New_Behavior_Para=Response_Vect;
end

  Match_Matrix=get_match_matrix(Class_Id,STIMULUS);
  Match_Matrix_Size=size(Match_Matrix);
  Response_Weight_Siz=size(Response_Weight);
  if Exist_Response
    for mm=1:Response_Weight_Siz(1)
      if Response_Weight(mm)==Class_Id
        if Response_Weight(mm:(mm+Match_Matrix_Size(1)-1),...
               1:Match_Matrix_Size(2))==Match_Matrix
          Begin_Row=mm;
          Stimulus_Num=(Begin_Row-1)/Match_Matrix_Size(1)+1;
          break;
        end
      end
    end
    Response_Weight(Begin_Row:(Begin_Row+Match_Matrix_Size(1)-1),...
            (Match_Matrix_Size(2)+1))=New_Behavior_Para;
   
    Stimulus_Counter(New_Age,Stimulus_Num)=...
           Stimulus_Counter(New_Age,Stimulus_Num)+1;  

  else
    Befor_Matrix=[Match_Matrix New_Behavior_Para];
    Response_Weight=[Response_Weight;Befor_Matrix];
 
    Counter_Size=size(Stimulus_Counter);
    Stimulus_Index=[Stimulus_Index;Match_Matrix];
    Stimulus_Counter(New_Age,Counter_Size(2)+1)=1;

  end

