function [Response_Id,STIMULUS,Region_Id,Exist_Response,Response_Vect]=...
            select_response(Class_Id,Region_Num,Cell_Density)
% SELECT_RESPONSE	Obtain stimulus for current cell and select a response_id.

%     Copyright (c) 1996-2000 Jiming Liu and Jianbing Wu

global Class_Id_Vector Response_Weight Stimulus_Size;
global Selection_Now;

[Max_Value,Max_Region_Num]=max(Cell_Density(2,1:Region_Num));

STIMULUS=zeros(Stimulus_Size);

STIMULUS(1,1)=-1;  % -1 --> this is the stimulus of OUT OF RADIUS

if isempty(Response_Weight)
  Exist_Response=0;
  Response_Id=get_random_response(Class_Id);
  Response_Vect=get_behavior_param(Class_Id);
  Vector_Size=size(Response_Vect);
  Number=0;
  for mm=1:Vector_Size(1)
    if Response_Vect(mm)~=-1
      Number=Number+1;
    end
  end
  for mm=1:Vector_Size(1)
    if Response_Vect(mm)~=-1
      Response_Vect(mm)=1.0/Number;
    end
  end
else
  [Response_Vect,Exist_Response]=get_match_response(Class_Id,...
                STIMULUS);
  if Exist_Response
    if Selection_Now==1 
      Response_Id=select_by_probab(Response_Vect);
    elseif Selection_Now==2
      [Response_Weight_Val,Response_Id]=max(Response_Vect);
    end
  else
    Response_Vect=get_behavior_param(Class_Id);
    Vector_Size=size(Response_Vect);
    Number=0;
    for mm=1:Vector_Size(1)
      if Response_Vect(mm)~=-1
        Number=Number+1;
      end
    end
    for mm=1:Vector_Size(1)
      if Response_Vect(mm)~=-1
        Response_Vect(mm)=1.0/Number;
      end
    end
    Response_Id=select_by_probab(Response_Vect);
  end
end

Region_Id=Max_Region_Num+Response_Id-1;  

if Region_Id>Region_Num
  Region_Id=Region_Id-Region_Num;
end
