function Step=step_by_mindist(Class_Id,Cel,Region_Id,X0,Y0,Step1)
% STEP_BY_MINDIST	Calculate the minimal step that a cell can 
%
%		move forward according to SET value:
%				Cell_Min_Distance  Red_White_Distance

%     Copyright (c) 1996-2000 Jiming Liu and Jianbing Wu

% (X0,Y0)=Current_Config
% (Xi,Yi): co-relation cell config
% Alpha: direction angle of moving
% alpha: vector angle of two cells

global CELL Region_Num Cell_Min_Distance Red_White_Distance;

Cell_Size=size(CELL);
Alpha=2*(Region_Id-0.5)*pi/Region_Num;
Min_Step=Step1;

for mm=1:Cell_Size(1)
  if CELL(mm,1)~=Class_Id | CELL(mm,2)~=Cel

    if CELL(mm,1)==Class_Id
      Delta_Radius=Cell_Min_Distance;
    else 
      Delta_Radius=Red_White_Distance;
    end

    Xi=CELL(mm,3);
    Yi=CELL(mm,4);    

    dist=sqrt((X0-Xi)^2+(Y0-Yi)^2);
    alpha=atan2(Yi-Y0,Xi-X0);
    if alpha<0
      alpha=2*pi+alpha;
    end

   % Beta: angle of two vectors, [0,pi]
    Beta=abs(Alpha-alpha);
    if Beta>pi
      Beta=2*pi-Beta;
    end

    if Beta>=pi/2
      Step_Posible=Min_Step;
    else
      if dist<Delta_Radius
        Step=0;
        return;
      elseif dist>=Delta_Radius & dist*sin(Beta)<Delta_Radius
        Step_Posible=dist*cos(Beta)-sqrt(Delta_Radius^2-(dist*sin(Beta))^2);
      elseif dist*sin(Beta)>=Delta_Radius 
        Step_Posible=Min_Step;
      end
    end
    Step=min(Min_Step,Step_Posible);
    Min_Step=Step;
  end
end     