function plot_cell
% PLOT_CELL	Plot the current location of the robots.

%     Copyright (c) 1996-2000 Jiming Liu and Jianbing Wu

global CELL Current_X Current_Y Visible_Width;

cla;
plot(Current_X,Current_Y,'color',[1 1 1]);
End_X=Current_X+Visible_Width; 
End_Y=Current_Y+Visible_Width;
axis([Current_X,End_X,Current_Y,End_Y]);
axis on;

Cell_Size=size(CELL);

hold on;

for mm=1:Cell_Size(1)
  Class_Id=CELL(mm,1);
  LocationX=CELL(mm,3);
  LocationY=CELL(mm,4);
  if LocationX<=End_X & LocationX>=Current_X ...
         & LocationY<=End_Y & LocationY>=Current_Y
    Cell_Color=get_cell_color(Class_Id);
    plot(LocationX,LocationY,'LineStyle','.','Color',Cell_Color,...
                 'erasemode','xor','markersize',200/Visible_Width);
   
  end
  drawnow;
end


