function [Response_Id,STIMULUS,Region_Id,Exist_Response,Response_Vect]=...
           get_inrad_response(Class_Id,Region_Num,Cell_Density)
% GET_INRAD_RESPONSE	Obtain the response_id for robots according to its Cell_Density.

%     Copyright (c) 1996-2000 Jiming Liu and Jianbing Wu

global Response_Weight Stimulus_Size Behavior_Now Selection_Now;

% -- operation to the case of BEHAVIOR
if Class_Id==2 
  Response_Id=0;
  Region_Id=0;
  STIMULUS=zeros(Stimulus_Size);
  if isempty(Response_Weight)
    Exist_Response=0;
    Response_Vect=get_behavior_param(Class_Id);
    Vector_Size=size(Response_Vect);
    for mm=1:Vector_Size(1)
      if Response_Vect(mm)~=-1
        Response_Vect(mm)=0;
      end
    end
  else
    [Response_Vect,Exist_Response]=get_match_response(Class_Id,...
                STIMULUS);
    if ~Exist_Response
      Response_Vect=get_behavior_param(Class_Id);
      Vector_Size=size(Response_Vect);
      for mm=1:Vector_Size(1)
        if Response_Vect(mm)~=-1
          Response_Vect(mm)=0;
        end
      end
    end
  end
  return;
else
 if Class_Id==1
  Cell_Distribute=Cell_Density(2,:);
 elseif Class_Id==2
  Cell_Distribute=Cell_Density(1,:);
 end
  for mm=1:Region_Num
    if Cell_Distribute(mm)>0
      Cell_Distribute(mm)=1;
    end
  end

  if isempty(Response_Weight)
    Exist_Response=0;
    Stimulus_Vector=zeros(Region_Num,1);
    Stimulus_Vector(1:Region_Num)=Cell_Distribute(1:Region_Num);
    STIMULUS=zeros(Stimulus_Size);
    STIMULUS(:,1)=Stimulus_Vector;

    Response_Id=get_random_response(Class_Id);
    Region_Id=Response_Id;
    Response_Vect=get_behavior_param(Class_Id);
    Vector_Size=size(Response_Vect);
    Number=0;        
    for mm=1:Vector_Size(1)
      if Response_Vect(mm)~=-1
        Number=Number+1;
      end            
    end              
    for mm=1:Vector_Size(1)
      if Response_Vect(mm)~=-1
        Response_Vect(mm)=1.0/Number;
      end            
    end             

    return;

  else
    for mm=0:(Region_Num-1)
      Stimulus_Vector=zeros(Region_Num,1);
      Is_Right_Shift=1;   % SHIFT to right
      if mm==0
        Stimulus_Vector(1:Region_Num)=Cell_Distribute(1:Region_Num);
      else 
        Stimulus_Vector(1:mm)=Cell_Distribute((Region_Num-mm+1):Region_Num);  
        Stimulus_Vector((mm+1):Region_Num)=Cell_Distribute(1:(Region_Num-mm)); 
      end

      STIMULUS=zeros(Stimulus_Size);
      STIMULUS(:,1)=Stimulus_Vector;
    
      [Response_Vect,Exist_Response]=get_match_response(Class_Id,...
                STIMULUS);
      if Exist_Response
       % operation of the case of LEARNING (selection mode)
        if Selection_Now==1 
          Response_Id=select_by_probab(Response_Vect);
        elseif Selection_Now==2
          [Response_Weight_Val,Response_Id]=max(Response_Vect);
        end
        Region_Id=Response_Id-mm;
        if Region_Id>Region_Num
          Region_Id=Region_Id-Region_Num;
        elseif Region_Id<0
          Region_Id=Region_Num+Region_Id;
        end
        return;

      else      % SHIFT to left 
        for nn=1:Region_Num
          STIMULUS(nn,1)=Stimulus_Vector(Region_Num-nn+1);
        end
        [Response_Vect,Exist_Response]=get_match_response(Class_Id,...
                  STIMULUS);
        if Exist_Response
          if Selection_Now==1 
            Response_Id=select_by_probab(Response_Vect);
          elseif Selection_Now==2 
            [Response_Weight_Val,Response_Id]=max(Response_Vect);
          end
          Region_Id=(Region_Num-Response_Id+1)-mm;
          if Region_Id>Region_Num
            Region_Id=Region_Id-Region_Num;
          elseif Region_Id<0
            Region_Id=Region_Num+Region_Id;
          end 
          return;
        end
      end
    end
  end
  
  %   New  -----
  Response_Vect=get_behavior_param(Class_Id);
  Vector_Size=size(Response_Vect);
  Number=0;
  for mm=1:Vector_Size(1)
    if Response_Vect(mm)~=-1
      Number=Number+1;
    end
  end
  for mm=1:Vector_Size(1)
    if Response_Vect(mm)~=-1
      Response_Vect(mm)=1.0/Number;
    end
  end
  Response_Id=select_by_probab(Response_Vect);
  Region_Id=Response_Id;
  STIMULUS(:,1)=Cell_Distribute';
end
  