function NumVector=dealnear(ConfigMatrix)
% DEALNEAR	Count the location numbers in each behavioral sector.
%
%		for robot selection.

%       Copyright (c) 1997-2000 Jiming Liu and Jianbing Wu

global EnvirSize ConfigInEnv;

MapGridWidth=5;
MapSize=[40 40];
RobotNum=10;
CompareValue=10;
MaxStep=16;
FreeIndex=256;

[X,map]=bmpread('testimg.bmp');

EnvirSize=size(X);

NumVector=[];
for loop1=1:MaxStep
  NumTheStep=0;
  for loop2=1:RobotNum
    ThisConfig=ConfigMatrix(loop2,(loop1-1)*2+1:loop1*2);

    ConfigInEnv=ThisConfig*MapGridWidth;

    if any(ConfigInEnv<CompareValue) | any(ConfigInEnv>(EnvirSize-10))
      NumTheStep=NumTheStep+1;
      break;
    end

    RowUp=ConfigInEnv(1)-CompareValue;
    if RowUp<=0
      RowUp=1;
    end

    RowDown=ConfigInEnv(1)+CompareValue;
    if RowDown>EnvirSize(1)
      RowDown=EnvirSize(1);
    end

    ColLeft=ConfigInEnv(2)-CompareValue;
    if ColLeft<=0
      ColLeft=1;
    end

    ColRight=ConfigInEnv(2)+CompareValue;
    if ColRight>EnvirSize(2)
      ColRight=EnvirSize(2);
    end

    IsInObstacle=0;
    for loop3=RowUp:RowDown
      for loop4=ColLeft:ColRight
        DeltaConfig=[loop3 loop4]-ConfigInEnv;
        Radius=sqrt(DeltaConfig(1)^2+DeltaConfig(2)^2);
        if Radius<CompareValue & X(loop3,loop4)~=FreeIndex
          IsInObstacle=1;
        end
      end
    end
    if IsInObstacle
      NumTheStep=NumTheStep+1;
    end
  end
  NumVector=[NumVector NumTheStep];
end