% DIRECTRESULT	Display the contour and robots trajectory at time T,
%
%		and save them into files.

%       Copyright (c) 1997-2000 Jiming Liu and Jianbing Wu

close all;
clear all;

RobotNum=10;
SensorNum=16;
MapSize=[40 40];
SaveInterval=2;
MapGridWidth=5;
TrajectInterval=4;

%FileName='Rand32r10s16st8e5w';
%FileName='dLsL32r10s16st8e5w';
%FileName='dLsS32r10s16st8e5w';
%FileName='Rand32r10s16st8e5wcor';
%FileName='dLsL32r10s16st8e5wcor';
FileName='dLsS32r10s16st8e5wcor';


eval(['load ' FileName ';']);
[X,map]=bmpread('testimg.bmp');
EnvSize=size(X);

for DisplayStep=4:TrajectInterval:32
DisplayStep

  BeginRow=(DisplayStep/SaveInterval-1)*MapSize(1)+1;
  EndRow=DisplayStep/SaveInterval*MapSize(1);
  PotentTemp=DirectPotent(BeginRow:EndRow,:);
%  PotentTemp=RandomPotent(BeginRow:EndRow,:);

  ThisPointPotent=PointsPotent(BeginRow:EndRow,:);

  subplot(3,2,1);
  surfl(PotentTemp);
  colormap(gray);
  view(-35,75);
  TitleString='Directional Potential ';
  TitleString=[TitleString ':'  FileName num2str(DisplayStep)];
  title(TitleString);

  subplot(3,2,2);
  surfl(ThisPointPotent);
  colormap(gray);
  view(-35,75);
  title('Accumulated Potential');

  subplot(3,2,3);
  contour(PotentTemp,40);

  subplot(3,2,4);
  contour(ThisPointPotent,40);  

  subplot(3,2,5);
  colormap(map);
  for mm=1:EnvSize(1)
    Y((EnvSize(1)-mm+1),:)=X(mm,:);
  end
  image(Y);
  hold on;
  for loop1=1:RobotNum
    X_Vector=[];
    Y_Vector=[];
    DataNum=0;
    for loop2=(DisplayStep-TrajectInterval):DisplayStep
     if loop2 
      LastConfig=AllRobotConfig(loop1,(loop2*2-1):2*loop2)*MapGridWidth;
      X_Vector=[X_Vector LastConfig(2)];
      Y_Vector=[Y_Vector LastConfig(1)];
      if loop2==DisplayStep
        plot(LastConfig(2),EnvSize(1)-LastConfig(1)+1,'*');
      else
        plot(LastConfig(2),EnvSize(1)-LastConfig(1)+1,'o');
      end
      DataNum=DataNum+1;
     end
    end
    t=1:DataNum;
    ts=1:.2:DataNum;
    xs=spline(t,X_Vector,ts);
    ys=spline(t,Y_Vector,ts);
    plot(xs,EnvSize(1)-ys+1);
  end

  subplot(3,2,6);
  LoopNum=DisplayStep*RobotNum*SensorNum;
  hold on;
  for loop1=1:LoopNum
    plot(AllEnvironPoints(loop1,2),AllEnvironPoints(loop1,1),'.');
  end 
  axis([1,EnvSize(2),1,EnvSize(1)]);
  axis off;

  eval(['print ' FileName '_'  num2str(DisplayStep) ' -dps;']);
end  