% FIGUREOUT	Display the potential field maps at certain steps
%
%		and corresponding robots trajectory, and save them into files.

%       Copyright (c) 1997-2000 Jiming Liu and Jianbing Wu

close all;
clear all;

RobotNum=10;
SensorNum=16;
MapSize=[40 40];
SaveInterval=2;
MapGridWidth=5;
%DisplayStep=14;
TrajectInterval=4;

%FileName='PRECISEs16e1';

FileName='Rand16r10s16st8e1w';                    
Keyword_m1='Rand_map';
Keyword_c1='Rand_cot';
Keyword_t1='Rand_trj';
Keyword_m2='Randpt_map';
Keyword_c2='Randpt_cot';
Keyword_t2='Randpt_trj';

%FileName='dMAXsMAX16r10s16st8e1w';                    
%Keyword_m1='dirLstepL_map';
%Keyword_c1='dirLstepL_cot';
%Keyword_t1='dirLstepL_trj';
%Keyword_m2='dirLstepLpt_map';  
%Keyword_c2='dirLstepLpt_cot';
%Keyword_t2='dirLstepLpt_trj';

%FileName='dMAXsMIN16r10s16st8e1w'; 
%Keyword_m1='dirLstepS_map';
%Keyword_c1='dirLstepS_cot';
%Keyword_t1='dirLstepS_trj';
%Keyword_m2='dirLstepSpt_map';
%Keyword_c2='dirLstepSpt_cot';
%Keyword_t2='dirLstepSpt_trj';

eval(['load ' FileName ';']);
[X,map]=bmpread('testimg.bmp');
EnvSize=size(X);

for DisplayStep=4:TrajectInterval:16
DisplayStep

PutString=['(STEP=' num2str(DisplayStep) ')'];

  BeginRow=(DisplayStep/SaveInterval-1)*MapSize(1)+1;
  EndRow=DisplayStep/SaveInterval*MapSize(1);
%  PotentTemp=DirectPotent(BeginRow:EndRow,:);
  PotentTemp=RandomPotent(BeginRow:EndRow,:);

  ThisPointPotent=PointsPotent(BeginRow:EndRow,:);

  clf;
  surfl(PotentTemp);
  colormap(gray);
  shading interp;
  view(-35,70);
  title(PutString);
  SaveString=[Keyword_m1 '_' num2str(DisplayStep)];
  eval(['print ' SaveString ' -dps;']);  
  drawnow;

  clf;
  surfl(ThisPointPotent);
  colormap(gray);
  shading interp;
  view(-35,70);
  title(PutString);
  SaveString=[Keyword_m2 '_' num2str(DisplayStep)];
  eval(['print ' SaveString ' -dps;']);
  drawnow;

  clf;
  contour(PotentTemp,30);
  colormap(gray);
  title(PutString);
  SaveString=[Keyword_c1 '_' num2str(DisplayStep)];
  eval(['print ' SaveString ' -dps;']);
  drawnow;

  clf;
  contour(ThisPointPotent,30);
  colormap(gray);
  title(PutString);  
  SaveString=[Keyword_c2 '_' num2str(DisplayStep)];
  eval(['print ' SaveString ' -dps;']);
  drawnow;

  clf;
  colormap(map);
  for mm=1:EnvSize(1)
    Y((EnvSize(1)-mm+1),:)=X(mm,:);
  end
  image(Y);
  hold on;
  for loop1=1:RobotNum
    X_Vector=[];
    Y_Vector=[];
    DataNum=0;
    for loop2=(DisplayStep-TrajectInterval):DisplayStep
     if loop2 
      LastConfig=AllRobotConfig(loop1,(loop2*2-1):2*loop2)*MapGridWidth;
      X_Vector=[X_Vector LastConfig(2)];
      Y_Vector=[Y_Vector LastConfig(1)];
      if loop2==DisplayStep
        plot(LastConfig(2),EnvSize(1)-LastConfig(1)+1,...
              'Marker','*','MarkerSize',7);
      else
        plot(LastConfig(2),EnvSize(1)-LastConfig(1)+1,...
              'Marker','o','MarkerSize',7);  % too small circle.
      end
      DataNum=DataNum+1;
     end
    end
    t=1:DataNum;
    ts=1:.2:DataNum;
    xs=spline(t,X_Vector,ts);
    ys=spline(t,Y_Vector,ts);
    plot(xs,EnvSize(1)-ys+1);
  end
  title(PutString);
  SaveString=[Keyword_t1 '_' num2str(DisplayStep)];
  eval(['print ' SaveString ' -dps;']);
  drawnow;

  clf;
  LoopNum=DisplayStep*RobotNum*SensorNum;
  hold on;
  for loop1=1:LoopNum
    plot(AllEnvironPoints(loop1,2),AllEnvironPoints(loop1,1),'.');
  end 
  axis([1,EnvSize(2),1,EnvSize(1)]);
  axis off;
  title(PutString);
  SaveString=[Keyword_t2 '_' num2str(DisplayStep)];
  eval(['print ' SaveString ' -dps;']);
  drawnow;
end  
