% POINTERRCAL Calculate and display the error of potential field map built by robots.

%       Copyright (c) 1997-2000 Jiming Liu and Jianbing Wu

clear all;
close all;

MapSize=[40 40];

load allpointpotent;

BeginPotent=zeros(MapSize);
TempError=BeginPotent-PrecisePotent;
BegnFirstSeg=sum(sum(TempError))/(40*40);
BegnSecSeg=sqrt(sum(sum(TempError.^2))/(40*40));
 
TimeAxis=0:2:16;

RandFirstSegment=[BegnFirstSeg];
RandSecondSegment=[BegnSecSeg];
for loop=1:8
  RandMatrix=RandPotent((loop-1)*MapSize(1)+1:loop*MapSize(1),:);
  TempError=RandMatrix-PrecisePotent;
  TempFirstSeg=sum(sum(TempError))/(40*40);
  TempSecSeg=sqrt(sum(sum(TempError.^2))/(40*40));
  RandFirstSegment=[RandFirstSegment TempFirstSeg];
  RandSecondSegment=[RandSecondSegment TempSecSeg];
end

dirLstepLFirstSeg=[BegnFirstSeg];
dirLstepLSecndSeg=[BegnSecSeg];
for loop=1:8
  dirLstepLMatrix=dirLstepLPotent((loop-1)*MapSize(1)+1:loop*MapSize(1),:);
  TempError=dirLstepLMatrix-PrecisePotent;
  TempFirstSeg=sum(sum(TempError))/(40*40);       
  TempSecSeg=sqrt(sum(sum(TempError.^2))/(40*40));
  dirLstepLFirstSeg=[dirLstepLFirstSeg TempFirstSeg];
  dirLstepLSecndSeg=[dirLstepLSecndSeg TempSecSeg];
end

dirLstepSFirstSeg=[BegnFirstSeg];
dirLstepSSecndSeg=[BegnSecSeg];
for loop=1:8
  dirLstepSMatrix=dirLstepSPotent((loop-1)*MapSize(1)+1:loop*MapSize(1),:);
  TempError=dirLstepSMatrix-PrecisePotent;
  TempFirstSeg=sum(sum(TempError))/(40*40);
  TempSecSeg=sqrt(sum(sum(TempError.^2))/(40*40));
  dirLstepSFirstSeg=[dirLstepSFirstSeg TempFirstSeg];
  dirLstepSSecndSeg=[dirLstepSSecndSeg TempSecSeg];
end

figure;
plot(TimeAxis,dirLstepLFirstSeg,'o-');
hold on;
plot(TimeAxis,dirLstepSFirstSeg,'--');
plot(TimeAxis,RandFirstSegment,'x-');

figure;
plot(TimeAxis,dirLstepLSecndSeg,'o-');
hold on;
plot(TimeAxis,dirLstepSSecndSeg,'x-');
plot(TimeAxis,RandSecondSegment,'--');

legend('directional 1','directional 2','random');
