% STATIS	Count the error distributions for different experiments,
%
%		and save them into files.

%       Copyright (c) 1997-2000 Jiming Liu and Jianbing Wu

clear all;

MapSize=[40 40];

load extracdata;

TimeAxis=2:2:16;

RandTimeErr=[];
RandError=[];
for loop=1:8
  RandMatrix=RandPotent((loop-1)*MapSize(1)+1:loop*MapSize(1),:);
  TempError=xor(RandMatrix,PrecisePotent);
  ErrorNum=sum(sum(TempError));
  RandTimeErr=[RandTimeErr ErrorNum];
  RandError=[RandError;~TempError+1];
end

MaxEdgError=[];
MaxEdgTimeErr=[];
for loop=1:8
  MaxEdgMatrix=MaxEdgPotent((loop-1)*MapSize(1)+1:loop*MapSize(1),:);
  TempError=xor(MaxEdgMatrix,PrecisePotent);
  ErrorNum=sum(sum(TempError));
  MaxEdgTimeErr=[MaxEdgTimeErr ErrorNum];
  MaxEdgError=[MaxEdgError;~TempError+1];
end

dirLstepLError=[];
dirLstepLTimeErr=[];
for loop=1:8
  dirLstepLMatrix=dirLstepLPotent((loop-1)*MapSize(1)+1:loop*MapSize(1),:);
  TempError=xor(dirLstepLMatrix,PrecisePotent);
  ErrorNum=sum(sum(TempError));
  dirLstepLTimeErr=[dirLstepLTimeErr ErrorNum];
  dirLstepLError=[dirLstepLError;~TempError+1];
end

dirLstepSError=[];
dirLstepSTimeErr=[];
for loop=1:8
  dirLstepSMatrix=dirLstepSPotent((loop-1)*MapSize(1)+1:loop*MapSize(1),:);
  TempError=xor(dirLstepSMatrix,PrecisePotent);
  ErrorNum=sum(sum(TempError));
  dirLstepSTimeErr=[dirLstepSTimeErr ErrorNum];
  dirLstepSError=[dirLstepSError;~TempError+1];
end

dirSstepLError=[];
dirSstepLTimeErr=[];
for loop=1:8
  dirSstepLMatrix=dirSstepLPotent((loop-1)*MapSize(1)+1:loop*MapSize(1),:);
  TempError=xor(dirSstepLMatrix,PrecisePotent);
  ErrorNum=sum(sum(TempError));
  dirSstepLTimeErr=[dirSstepLTimeErr ErrorNum];
  dirSstepLError=[dirSstepLError;~TempError+1];
end

dirSstepSError=[];
dirSstepSTimeErr=[];
for loop=1:8
  dirSstepSMatrix=dirSstepSPotent((loop-1)*MapSize(1)+1:loop*MapSize(1),:);
  TempError=xor(dirSstepSMatrix,PrecisePotent);
  ErrorNum=sum(sum(TempError));
  dirSstepSTimeErr=[dirSstepSTimeErr ErrorNum];
  dirSstepSError=[dirSstepSError;~TempError+1];
end

save timerror RandTimeErr MaxEdgTimeErr dirLstepLTimeErr dirLstepSTimeErr...
       dirSstepLTimeErr dirSstepSTimeErr;
save pperror RandError MaxEdgError dirLstepLError dirLstepSError ...
       dirSstepLError dirSstepSError;
