function NewRobotConfig=newrobot(RobotConfig,LastPotent)
% NEWROBOT	Sample function to assign the new locations for robots.

%       Copyright (c) 1997-2000 Jiming Liu and Jianbing Wu

global MaxMoveStep SensorNum RobotNum MapSize MapGridWidth RealEnviron;
global RobotIndex FreeIndex ObstacleIndex PotentTemp;

NewRobotConfig=[];
SetRobotEnv=RealEnviron;

for mm=1:RobotNum
  OldRobotConfig=RobotConfig(mm,:);
  
  RowUp=OldRobotConfig(1)- MaxMoveStep;
  if RowUp<=0
    RowUp=1;
  end
  RowDown=OldRobotConfig(1)+MaxMoveStep;
  if RowDown>MapSize(1)
    RowDown=MapSize(1);
  end

  ColLeft=OldRobotConfig(2)- MaxMoveStep;
  if ColLeft<=0
    ColLeft=1;
  end
  ColRight=OldRobotConfig(2)+MaxMoveStep;
  if ColRight>MapSize(2)
    ColRight=MapSize(2);
  end

  IntervalCounter=zeros(1,SensorNum);
 
  TimeDeviation=[];
  for loop1=RowUp:RowDown
    for loop2=ColLeft:ColRight
      DeltaConfig=[loop1 loop2]-OldRobotConfig;
      TheInterval=getinterval(DeltaConfig);
      Col=IntervalCounter(TheInterval)+1;
      IntervalCounter(TheInterval)=Col;
      TimeDeviation(TheInterval,Col)=PotentTemp(loop1,loop2)-...
              LastPotent(loop1,loop2);
    end
  end

  IntervalStd=zeros(1,SensorNum);
  for loops=1:SensorNum
    TheVector= TimeDeviation(loops,1:IntervalCounter(loops));
    if ~isempty(TheVector)
      IntervalStd(loops)=std(TheVector);
    end
  end    

  isGoon=1;
  while isGoon
    [MaxStd,SelectInterval]=max(IntervalStd);
    IntervalStd(SelectInterval)=0;

    RecordTemp=[];    %N*3 ---[std Row Col]
    for loop1=RowUp:RowDown
      for loop2=ColLeft:ColRight
        DeltaConfig=[loop1 loop2]-OldRobotConfig;
        TheInterval=getinterval(DeltaConfig);
        if TheInterval==SelectInterval
          StdTemp=[];
          for loop3=(loop1-1):(loop1+1)
            for loop4=(loop2-1):(loop2+1)
              if all([loop3 loop4]>0) & all([loop3 loop4]<=MapSize)
                StdTemp=[StdTemp PotentTemp(loop3,loop4)];
              end
            end
          end
          CurrentStd=std(StdTemp);
          RecordTemp=[RecordTemp;CurrentStd loop1 loop2];
        end
      end
    end

    TempVector=RecordTemp(:,1);
    [MaxStd,Col]=max(TempVector);

    SelectAgain=1;
    while SelectAgain
      if isempty(RecordTemp)
        break;
      end
      NewPosition=RecordTemp(Col,2:3);

      DeltaPos=NewPosition-OldRobotConfig;
      Step=sqrt(DeltaPos(1)^2+DeltaPos(2)^2);
      Angle=atan2(-DeltaPos(1),DeltaPos(2));
 
      InEnvironPos=NewPosition*MapGridWidth;
      if SetRobotEnv(InEnvironPos(1),InEnvironPos(2))==FreeIndex
        SelectAgain=0;
        for loop=1:floor(Step*MapGridWidth)
          IdentPos=OldRobotConfig*MapGridWidth+[-round(loop*sin(Angle))...
               round(loop*cos(Angle))];
          if SetRobotEnv(IdentPos(1),IdentPos(2))==ObstacleIndex
            SelectAgain=1;
            RecordTemp(Col,:)=[];
            TempVector=RecordTemp(:,1);
            [MaxStd,Col]=max(TempVector);
            break;
          end
        end
        if ~SelectAgain
          NewRobotConfig=[NewRobotConfig;NewPosition];
          SetRobotEnv(InEnvironPos(1),InEnvironPos(2))=RobotIndex;
          isGoon=0;
        end
      else
        RecordTemp(Col,:)=[];
        TempVector=RecordTemp(:,1);
        [MaxStd,Col]=max(TempVector);
      end
    end
  end
end