function showmap(FigHandleMap,FigHandleImg,ContourMap,FigErrorMap,...
             FigErrorPoint,FigHandleEnv)
% SHOWMAP	Display the potential field map and robots environment.
%
%		FigHandleMap  ---for Potential Field Map.
%		FigHandleImg  ---for Robotic Environment.
%		ContourMap    ---for CONTOUR drawing of PotentField.

%       Copyright (c) 1997-2000 Jiming Liu and Jianbing Wu

global PotentTemp VisitPlusEnviron ColorMap ThisPointPotent;
global ThisDirectError ThisPointError;

if ~isempty(PotentTemp)
  figure(FigHandleMap);
  clf;
  surfl(PotentTemp);
  view(-40,50);

  figure(ContourMap);
  clf;
  contour(PotentTemp,10);

  figure(FigHandleImg);
  clf;
  surfl(ThisPointPotent);
  view(-40,50);

  figure(FigErrorMap);
  clf;
  surfl(ThisDirectError);
  view(-40,50);

  figure(FigErrorPoint);
  clf;
  surfl(ThisPointError);
  view(-40,50);

end

figure(FigHandleEnv);
clf;
colormap(ColorMap);
image(VisitPlusEnviron);

drawnow;