% MASOMAIN	Main program for
%
% 	self-organization of potential field map
% 	by group of autonomous robots.
                        
%       Copyright (c) 1997-2000 Jiming Liu and Jianbing Wu

clear all;
close all;

global RobotIndex FreeIndex ObstacleIndex TRUE FALSE; 
global RealEnviron MapGridWidth EnvironSize MapSize ColorMap;
global RobotNum SensorType SensorNum RobotConfig;
global VisitTimes PotentFunc VisitPlusEnviron AllEnvironPoints;
global MarkColorIndex MaxMoveStep MaxAttitude TempPotentWeight;
global AccumulateNum TempPotentField PotentTemp ThisPointPotent;
global DirectPotent TotalPotent EnvironPoints AllRobotConfig;
global ThisDirectError ThisPointError PrecisePotent;

% ---- Initialization ----
globini;
getenvir;
robotini;
getrobot;

% --- Running ---
LastPotent=ones(MapSize)*2;
for RunTimes=1:32
  RunTimes            %%%%%%%%%%%%%%%

  AllRobotConfig=[AllRobotConfig RobotConfig];

  RobotUnrunList=1:RobotNum;
  for loop1=1:RobotNum
    UnrunNumber=size(RobotUnrunList);
    SelectNumber=ceil(rand*UnrunNumber(2));
    SelectedRobot=RobotUnrunList(SelectNumber);
    RobotUnrunList(SelectNumber)=[];

    SensingResult=[];
    for loop2=1:SensorNum
      ReturnValue=feval(SensorType,SelectedRobot,loop2);
      SensingResult=[SensingResult;ReturnValue];
    end

    DeltaWeight=callsom(SensingResult,SelectedRobot);

  end

  PotentTemp=getpotent;
  for mm=1:MapSize(1)
    for nn=1:MapSize(2)
      if ~PotentTemp(mm,nn)
        PotentTemp(mm,nn)=9;
      end
      if PotentTemp(mm,nn)>9
        PotentTemp(mm,nn)=9;
      end
    end
  end

  if ~rem(RunTimes,2)

    DirectPotent=[DirectPotent;PotentTemp];
    ThisDirectError=PrecisePotent-PotentTemp;

    ThisPointPotent=pointcal;
    TotalPotent=[TotalPotent;ThisPointPotent];
    ThisPointError=PrecisePotent-ThisPointPotent;

%    for mm=1:MapSize(1)
%      for nn=1:MapSize(2)
%        PointDraw(MapSize(1)-mm+1,nn)=ThisPointPotent(mm,nn);
%        if PotentTemp(mm,nn)
%          PotentField(MapSize(1)-mm+1,nn)=PotentTemp(mm,nn);
%        else
%          PotentField(MapSize(1)-mm+1,nn)=2;
%          PotentTemp(mm,nn)=2;
%        end
%      end
%    end

%    showmap(FigHandleMap,FigHandleImg,ContourMap,FigErrorMap,...
%             FigErrorPoint,FigHandleEnv);

  end

  RobotConfig=newrobot(RobotConfig,LastPotent);

  LastPotent=PotentTemp;

end
[SaveDirectory,SaveItem]=saveini;
eval(['save ' SaveDirectory ' ' SaveItem ';']);