function PotentTemp=getpotent
% GETPOTENT	Incremental self-organization calculation of potential field map.

%       Copyright (c) 1997-2000 Jiming Liu and Jianbing Wu

global TempPotentField TempPotentWeight MapSize AccumulateNum;

PotentTemp=zeros(MapSize(1),MapSize(2));

for loop1=1:MapSize(1)
  for loop2=1:MapSize(2)
    PotentCache=[];
    WeightCache=[];
    for loopAccumulate=1:AccumulateNum
      if TempPotentField(loop1,loop2,loopAccumulate)~=-1
        PotentCache=[PotentCache TempPotentField(loop1,loop2,loopAccumulate)];
        WeightCache=[WeightCache ...
              TempPotentWeight(loop1,loop2,loopAccumulate)];
      else
        break;
      end
    end
    if ~isempty(PotentCache)
      [MaxWeight,WhichOne]=max(WeightCache);
      if MaxWeight==1
        PotentTemp(loop1,loop2)=PotentCache(WhichOne);
      else
        WeightCache=WeightCache/sum(WeightCache);
        PotentTemp(loop1,loop2)=PotentCache*WeightCache';
        PotentTemp(loop1,loop2)=mean(PotentCache);
      end
    end
  end
end